#!/usr/bin/env python
# coding=utf-8

##    Qemulator 0.3 - a qemu gui written in python and GTK/Glade.
##    Copyright (C) 2006  rainer haage
##
##    This program is free software; you can redistribute it and/or
##    modify it under the terms of the GNU General Public License
##    as published by the Free Software Foundation; either version 2
##    of the License, or (at your option) any later version.
##    
##    This program is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##    
##    You should have received a copy of the GNU General Public License
##    along with this program; if not, write to the Free Software
##    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

import sys
import os
from os import path
import popen2
from popen2 import Popen3
import gobject
#import gettext
import string
import pickle
import time
import threading

from threading import Thread
import re
from copy import copy
from copy import deepcopy

try:
    import gettext
    import locale
except:
    print "locale and/or gettext for language support not installed"





gobject.threads_init()

try:
    import pygtk
    pygtk.require("2.0")
    
except:
  	print "pygtk 2.0 is not installed"
try:
    import gtk
    import gtk.glade
    
except:
    print "gtk and/or glade is not installed - exiting..."
    sys.exit(1)
    
#from pygtk import tooltips
    
APP = 'Qemulator'
DIR = 'locale'

locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain(APP, DIR)
gettext.textdomain(APP)
_ = gettext.gettext

gtk.glade.bindtextdomain(APP, DIR)
gtk.glade.textdomain(APP)
tooltips = gtk.Tooltips()    

class Qemulator(Thread):
    #class testit(Thread):

    #print 'Qemulator started'
    print  _('Qemulator started')
      
    #data=os.listdir("/home/rainer/emu-iso")
    
    def create_model_ilist(self, data):
        store = gtk.ListStore(gobject.TYPE_STRING,
                          gtk.gdk.Pixbuf)
        config_icon = gtk.Image()
        try:
            for item in data:
                iter = store.append()
                #itempath = self.settings["imagespath"] + "/" + item[0]
                itempath = item[0]
                haveconfig = item[1]
                #haveconfig = self.check_haveconfig(path)
                #print "haveconfig: " + str(haveconfig)
                if haveconfig == True:
                    config_icon = gtk.gdk.pixbuf_new_from_file('pixmaps/gtk-yes.png')
                else:
                    config_icon = gtk.gdk.pixbuf_new_from_file('pixmaps/gtk-no.png')                
                store.set(iter, 0, itempath, 1, config_icon)
        except:
            # no settings
            pass
        return store
        
        
    def add_columns(self, treeview):
        model = self.isolist.get_model()
        renderer = gtk.CellRendererToggle()
        column = gtk.TreeViewColumn(_('Qemu Images'), gtk.CellRendererText(), text=0)
        column2 = gtk.TreeViewColumn(_('configured'), gtk.CellRendererPixbuf(), pixbuf=1)
        #column3 = gtk.TreeViewColumn(_('configured'), gtk.CellRendererPixbuf(), pixbuf=3)
        treeview.append_column(column)
        treeview.append_column(column2)
   
            
    ## actions when an image file was selected        
    #def treeview_selection(self, widget, path, view_column):
    def treeview_selection(self, widget):
        model, iter = widget.get_selection().get_selected()
        row = model[iter]
        item = row[0]
        print "item: %s" %item
        self.set_currentimage(item) 
        
        print "item: %s" %item

    ## Function to set the current emu-image when double-clicking an Entry
    def set_currentimage(self, imgstring):
        if imgstring != None:
            self.entry_current_image.set_text(imgstring)
            self.activate_launchbuttons( True )
            #self.currentimage = imgstring        
            
            #self.fetch_currimage_config()
    ## Universal Function to pickle-store the configfiles
    def storetofile(self, indata, filename):
        #print "storefile: " + filename
        dumpf = open("config/" + filename ,"w")        
        pickle.dump(indata, dumpf)
        dumpf.close()
    ## Universal Function to open the pickle'd configfiles        
    def getfromfile(self, filename):
        try:
            abs_path = path.abspath("config/" + filename)
            print "opened file absolute path: " + abs_path
            #dumpf = open("config/" + filename ,"r")  
            dumpf = open( abs_path ,"r")       
            outdata = pickle.load(dumpf)
            dumpf.close()
            return outdata        
        except:
            outdata  = { }
            #outdata["NULL"] = {"kqemu_param": "-kernel-kqemu", "bootmedium": "cdrom", "boot_driveletter": "d"}
            print "no config file"
            return outdata
            
    def match_func(self, model, iter, data):
       column, key = data # data is a tuple containing column number, key
       value = model.get_value(iter, column)
       return value == key
       
    def search(self, model, iter, func, data):
       while iter:
           if func(model, iter, data):
               return iter
           result = search(model, model.iter_children(iter), func, data)
           if result: return result
           iter = model.iter_next(iter)
       return None
    ## Searches for the index for a 1 dimensional treemodel
    def search_combolist(self, combobox, searchstring):
        ct = 0
        outct = ""
        cdmodel = combobox.get_model()
        #print "cdmodel: " + str(cdmodel)
        for row in cdmodel:

            if searchstring == row[0]:
                #print "row: " + row[0]
                #print "ct: " + str(ct)
                outct = ct
                
            ct = ct + 1      
        #print "outct: " + str(outct)            
        return outct    


    ## Fetch the stored configuration for the selected image
    def fetch_currimage_config(self, *widget):
        #try:
        self.image_settings = self.getfromfile("image_settings")
        haveconfig = False
        try:
            if self.image_settings[self.currentimage]:
                print "Config found"
                haveconfig = True
            else:
                print "No config found"
                self.label_imgsettings.set_markup(_('<b>Create new Settings for Current selected image</b>'))
                haveconfig = False
        except:
            self.label_imgsettings.set_markup(_('<b>Create new Settings for Current selected image</b>'))
            print "No config for this image found" 
            haveconfig = False
        
        if haveconfig == True:
            self.change_emu_setting("emusystem")
            self.change_emu_setting("machine")
            #print self.image_settings[self.currentimage]["kqemu_param"]
            self.change_emu_setting("kqemu_param")
            #print self.image_settings[self.currentimage]["bootmedium"]
            self.change_emu_setting("bootmedium")
            #print self.image_settings[self.currentimage]["boot_driveletter"]
            self.boot_driveletter = self.image_settings[self.currentimage]["boot_driveletter"]
            self.change_emu_setting("cdrmedium")
            self.change_emu_setting("cdrimage")
            if self.cdrmedium == "" and self.cdrimage == "":
                self.radiobutton_cdromtype.set_active( True );
            self.change_emu_setting("xtraimages")                    
            
            self.change_emu_setting("networksetup")
            self.change_emu_setting("soundhw")
            self.change_emu_setting("vgamode")
            self.change_emu_setting("novga")
            self.change_emu_setting("usevnc")
            self.change_emu_setting("memory")
            self.change_emu_setting("useusb")
            self.change_emu_setting("snapshotmode")
            self.change_emu_setting("localtimemode")
            #self.change_emu_setting("networkoptions")
            self.change_emu_setting("customoptions")
            #self.change_emu_setting("bootfromcd")
            self.label_imgsettings.set_markup(_('<b>Stored Settings for Current selected image</b>'))
            self.button_apply_imagesettings.set_sensitive(False)
            self.button_restore_imagesettings.set_sensitive(False)
            if self.settings_autohide == True:
                self.switch_settingsview("hide")
        else:
            self.button_apply_imagesettings.set_sensitive(True)
            self.networkmode = "usermode"
            self.radiobutton_network_usermode.set_active(True)
            if self.settings_autoshow == True:
                self.switch_settingsview("show")
            #self.button_restore_imagesettings.set_sensitive(True)

       # except:
        #    print "no custom settings available"
        #    self.label_imgsettings.set_markup(_('<b>Create new Settings for Current selected image</b>'))
            
        #    self.button_apply_imagesettings.set_sensitive(True)
        #    self.button_restore_imagesettings.set_sensitive(False)
        self.notebook_imgsettings.set_sensitive(True)
        self.button_add_bookmark.set_sensitive(True)
    ## change settings for current image    
    
    def fetch_currimage_info(self, *widget):
        command = "qemu-img info " + self.currentimage
        info = os.popen(command).read()
        return info
        
    def fetch_image_info(self, image):
        info = _('no valid image selected')  
       
        try:
            command = "qemu-img info " + image
            info = os.popen(command).read()
        except:
            #info = "no valid image selected"
            info = _('no valid image selected')  
        return info        
    
    def change_emu_setting(self, emuparam):
    
        if emuparam == "emusystem":
            try:        
                self.emusystem = self.image_settings[self.currentimage]["emusystem"]
                self.qemubin = self.emusystem_path_by_name(self.emusystem)
                print  _('emusystem loaded: ') + self.emusystem
                 
                #settings = self.settings["emusystem"]
                actct2 = self.search_combolist(self.combobox_emusystem, self.emusystem)
                #print "actct2 " + str(actct2)
                if actct2 != "":
                    self.combobox_emusystem.set_active(actct2)     
                    #self.radiobutton_cdromtype2.set_active( True );       
            except:
                self.combobox_emusystem.set_active(0)
                print "no emusystem choosen"       
                
        elif emuparam == "machine":
            try:        
                self.machine = self.image_settings[self.currentimage]["machine"]
                self.machinecommand = self.machine_path_by_name(self.machine)
                #if self.machinecommand == "None":
                #    self.machinecommand = ""
                
                print "machine loaded: " + self.machinecommand
                #settings = self.settings["emusystem"]
                actct2 = self.search_combolist(self.combobox_machinetype, self.machine)
                #print "actct2 " + str(actct2)
                if actct2:
                    self.combobox_machinetype.set_active(actct2)     
                    #self.radiobutton_cdromtype2.set_active( True );       
            except:
                self.combobox_machinetype.set_active(0)
                print "no machine choosen"                  

        elif emuparam == "kqemu_param":
            try:            
                load_kqemu_param = self.image_settings[self.currentimage]["kqemu_param"]
                if load_kqemu_param == "NULL":
                    self.kqemu_param = ""
                else:
                    self.kqemu_param = load_kqemu_param
                
                if self.kqemu_param ==  "-no-kqemu":
                    self.radiobutton_nokqemu.set_active( True );
                elif self.kqemu_param ==  "":
                    self.radiobutton_kqemu.set_active( True );
                elif self.kqemu_param ==  "-kernel-kqemu":
                    self.radiobutton_kkqemu.set_active( True );      
                print "kqemu_param: " + self.kqemu_param
            except:
                print "no settings for " + emuparam
            
        elif emuparam == "bootmedium":
            self.bootmedium = self.image_settings[self.currentimage]["bootmedium"]
            print "bootmedium: " + self.bootmedium
            if self.bootmedium ==  "cdrom":
                self.combobox_imagedevice.set_active(1);
            elif self.bootmedium ==  "fda":
                self.combobox_imagedevice.set_active(2);                
            else:
                self.combobox_imagedevice.set_active(0);
                
        elif emuparam == "cdrmedium":
            try:
                self.cdrmedium = self.image_settings[self.currentimage]["cdrmedium"]
                print "cdrmedium loaded: " + self.cdrmedium
                settings = self.settings["cdromdrives"]
                actct = self.search_combolist(self.combobox_cdromdrive, self.cdrmedium)
                print "actct " + str(actct)
                if actct:
                    print "actct " + str(actct)
                    self.combobox_cdromdrive.set_active(actct)
                    self.radiobutton_cdromtype1.set_active( True );
            except:
                print "no cdrmedium choosen"
                
        elif emuparam == "cdrimage":
            try:        
                self.cdrimage = self.image_settings[self.currentimage]["cdrimage"]
                print "cdrimage: " + self.cdrimage
                settings = self.settings["cdromdrives"]
                actct2 = self.search_combolist(self.combobox_imagecdrom, self.cdrimage)
                print "actct2 " + str(actct2)
                if actct2:
                    self.combobox_imagecdrom.set_active(actct2)     
                    self.radiobutton_cdromtype2.set_active( True );       
            except:
                self.combobox_imagecdrom.set_active(0)
                print "no cdrimage choosen"    
          
        elif emuparam == "xtraimages":
            try:        
                self.hda_image = self.image_settings[self.currentimage]["hda_image"]
                if self.hda_image == "None":
                    self.hda_image = None
                print "hda_image: " + str(self.hda_image)
                
                self.filechooserbutton_hda.set_filename(self.hda_image)
                tooltips.set_tip(self.eventbox_filechooserbutton_hda, str(self.hda_image))
                try:
                    actct_hda = self.search_combolist(self.combobox_hda, self.hda_image)
                    self.combobox_hda.set_active(actct_hda)    
                except:
                    pass
            except:
                self.combobox_hda.set_active(0)
                print "no hdaimage choosen"    
                #self.hda_image = "None"
            actct = 0
            try:        
                self.hdb_image = self.image_settings[self.currentimage]["hdb_image"]
                print "hdb_image: " + self.hdb_image
                #settings = self.settings["cdromdrives"]
                actct_hdb = self.search_combolist(self.combobox_hdb, self.hdb_image)
                #print "actct_hdb " + str(actct_hdb)
                #if actct_hdb:
                self.combobox_hdb.set_active(actct_hdb)     
            except:
                self.combobox_hdb.set_active(0)
                print "no hdbimage choosen"  
            actct = 0                
            try:        
                self.hdc_image = self.image_settings[self.currentimage]["hdc_image"]
                print "hdc_image: " + self.hdc_image
                #settings = self.settings["cdromdrives"]
                actct_hdc = self.search_combolist(self.combobox_hdc, self.hdc_image)
                #print "actct_hdc " + str(actct_hdc)
                #if actct_hdc:
                self.combobox_hdc.set_active(actct_hdc)     
            except:
                self.combobox_hdc.set_active(0)
                print "no hdcimage choosen"    
            actct = 0                
            try:        
                self.hdd_image = self.image_settings[self.currentimage]["hdd_image"]
                print "hdd_image: " + self.hdd_image
                #settings = self.settings["cdromdrives"]
                actct_hdd = self.search_combolist(self.combobox_hdd, self.hdd_image)
                #print "actct_hdd " + str(actct_hdd)
                #if actct_hdd:
                self.combobox_hdd.set_active(actct_hdd)     
            except:
                self.combobox_hdd.set_active(0)
                print "no hddimage choosen"      
            #actct = 0                
            try:        
                self.fda_image = self.image_settings[self.currentimage]["fda_image"]
                print "fda_image: " + self.fda_image
                #settings = self.settings["cdromdrives"]
                actct_fda = self.search_combolist(self.combobox_fda, str(self.fda_image))
                #print "actct_fda " + str(actct_fda)
                #if actct_fda:
                self.combobox_fda.set_active(actct_fda)     
            except:
                self.combobox_fda.set_active(0)
                print "no fdaimage choosen"  
            #actct = 0                
            try:        
                self.fdb_image = self.image_settings[self.currentimage]["fdb_image"]
                print "fdb_image: " + self.fdb_image
                #settings = self.settings["cdromdrives"]
                actct_fdb = self.search_combolist(self.combobox_fdb, str(self.fdb_image))
                #print "actct_fdb " + str(actct_fdb)
                #if actct_fdb:
                self.combobox_fdb.set_active(actct_fdb)     
            except:
                self.combobox_fdb.set_active(0)
                print "no fdbimage choosen"                  
        elif emuparam == "networksetup":   
            try: 
                self.networkmode = self.image_settings[self.currentimage]["networkmode"]
                print "networkmode loaded"
                if self.networkmode == "nonet":
                    self.radiobutton_network_nonet.set_active(True)
                elif self.networkmode == "usermode" or self.networkmode == "":
                    self.radiobutton_network_usermode.set_active(True)
                elif self.networkmode == "custom":
                    self.radiobutton_network_customsetup.set_active(True)  
                else:
                    self.radiobutton_network_usermode.set_active(True)
                #self.entry_network_hostname.set_text(self.network_hostname)                                                                             
                
            except:
                self.networkmode = "usermode"
                self.radiobutton_network_usermode.set_active(True)                  
                print "no networkmode to load"            
            try:
                self.usernetwork = self.image_settings[self.currentimage]["usernetwork"]
                
                #self.network_hostname = self.image_settings[self.currentimage]["network_hostname"] 
            except:
                self.usernetwork = Network_Usernet()
                
            try:
                self.smbsettings = self.image_settings[self.currentimage]["smbsettings"]
            except:
                self.smbsettings = Network_SMB()
                #self.smbsettings = []
            print "self.smbsettings.usesmb: " + str(self.smbsettings.usesmb)
            self.checkbutton_smbshare.set_active(self.smbsettings.usesmb)
            self.filechooserbutton_network_smbshare.set_filename(str(self.smbsettings.smbpath))
                #self.network_hostname = "emu"
            print "self.smbsettings.smbpath: " + str(self.smbsettings.smbpath)
            self.spinbutton_usernet_vlan.set_value(int(self.usernetwork.vlan))
            self.entry_network_hostname.set_text(str(self.usernetwork.hostname))
                                 
            try: 
                self.networksetup = self.image_settings[self.currentimage]["networksetup"]
                print "networksettings loaded"
            except:
                self.networksetup = []
                print "no networksettings to load"
            try: 
                self.networkredirs = self.image_settings[self.currentimage]["networkredirs"]
                print "networkredirs loaded"
            except:
                self.networkredirs = []
                print "no networkredirs to load"                
            #try:
            self.refresh_networkcards()
            self.refresh_redirects()
            #except:
            #    print "no networksettings"
            #print "Networksettings loaded"
                
        elif emuparam == "soundhw":
            try:        
                self.soundhw = self.image_settings[self.currentimage]["soundhw"]
                print "soundhw: " + self.soundhw
                #settings = self.settings["soundhw"]
                actct2 = self.search_combolist(self.combobox_audiohw, self.soundhw)
                #print "actct2 " + str(actct2)
                if actct2:
                    self.combobox_audiohw.set_active(actct2)     
                else:
                    self.combobox_audiohw.set_active(0)     
            except:
                self.combobox_audiohw.set_active(0)
                print "no soundhw choosen"    
        elif emuparam == "vgamode":  
            try:
                self.vgamode = self.image_settings[self.currentimage]["vgamode"]
                print "vgamode: " + self.vgamode
                if self.vgamode == "std-vga":
                    self.checkbutton_usevga.set_active(True)
                else:
                    self.checkbutton_usevga.set_active(False)
            except:
                self.checkbutton_usevga.set_active(False)
                print "no settings for " + emuparam   
                self.vgamode = "default"
        elif emuparam == "usevnc":  
            try:
                self.usevnc = self.image_settings[self.currentimage]["usevnc"]
                self.vncdisplay = self.image_settings[self.currentimage]["vncdisplay"]
                self.spinbutton_vncdisplay.set_value(self.vncdisplay)
                print "usevnc: " + self.usevnc
                if self.usevnc == "novnc":
                    self.checkbutton_startvnc.set_active(False)
                else:
                    self.checkbutton_startvnc.set_active(True)
            except:
                self.checkbutton_startvnc.set_active(False)
                self.usevnc = "novnc"
                self.vncdisplay = "1"
                print "no settings for " + emuparam       
                
        elif emuparam == "memory":  
            try:
                self.memory = self.image_settings[self.currentimage]["memory"]
                #self.vncdisplay = self.image_settings[self.currentimage]["vncdisplay"]
                self.spinbutton_memory.set_value(self.memory)
                #print "memory loaded: " + str(self.memory)
            except:
                self.checkbutton_startvnc.set_active(False)
                self.usevnc = "novnc"
                self.memory = "128"
                print "no settings for " + emuparam       
                
        elif emuparam == "useusb":  
            try:
                self.useusb = self.image_settings[self.currentimage]["useusb"]
                #print "useusb: " + str(self.useusb)
                self.checkbutton_enable_usb.set_active(self.useusb)
            except:
                self.checkbutton_enable_usb.set_active(False)
                print "no settings for " + emuparam   
                self.useusb = False

        elif emuparam == "novga":  
            try:
                self.novga = self.image_settings[self.currentimage]["novga"]
                #print "novga: " + str(self.novga)
                self.checkbutton_novga.set_active(self.novga)
            except:
                self.checkbutton_novga.set_active(False)
                print "no settings for " + emuparam   
                self.novga = False
                #self.novga                
                
        elif emuparam == "snapshotmode":  
            try:
                self.snapshotmode = self.image_settings[self.currentimage]["snapshotmode"]
                #print "snapshotmode: " + str(self.snapshotmode)
                self.checkbutton_snapshotmode.set_active(self.snapshotmode)
            except:
                self.checkbutton_snapshotmode.set_active(False)
                print "no settings for " + emuparam   
                self.snapshotmode = False  
                
        elif emuparam == "localtimemode":  
            try:
                self.localtimemode = self.image_settings[self.currentimage]["localtimemode"]
                #print "localtimemode: " + str(self.localtimemode)
                self.checkbutton_localtime.set_active(self.localtimemode)
            except:
                self.checkbutton_localtime.set_active(False)
                print "no settings for " + emuparam   
                self.localtimemode = False                  
                
        elif emuparam == "networkoptions":  
            try:
                self.networkoptions = self.image_settings[self.currentimage]["networkoptions"]
                #print "networkoptions: " + str(self.networkoptions)
            except:
                print "no settings for " + emuparam   
                self.networkoptions = ""               
            self.entry_networkline.set_text(self.networkoptions)
            
        elif emuparam == "customoptions":  
            try:
                self.customoptions = self.image_settings[self.currentimage]["customoptions"]
                #print "customoptions: " + str(self.customoptions)
            except:
                print "no settings for " + emuparam   
                self.customoptions = ""               
            self.entry_additional_options.set_text(self.customoptions)            
        elif emuparam == "bootfromcd":  
            try:
                self.bootfromcd = self.image_settings[self.currentimage]["bootfromcd"]
                #print "bootfromcd: " + str(self.bootfromcd)
                self.checkbutton_bootcdrom.set_active(self.bootfromcd)
            except:
                self.checkbutton_bootcdrom.set_active(False)
                print "no settings for " + emuparam   
                self.bootfromcd = False    
        else:
            print "no value for the option " + emuparam
            
            
    ## Store changed settings for current image to file        
    def store_emu_settings(self, widget):
        #try:
        if self.currentimage != "":
            if self.kqemu_param == "":
                store_kqemu_param = "NULL"
            else:
                store_kqemu_param = self.kqemu_param
                
            if self.radiobutton_cdromtype1.get_active()  == True:
                self.cdrimage = ""
            elif self.radiobutton_cdromtype2.get_active()  == True:
                self.cdrmedium = ""
            elif self.radiobutton_cdromtype.get_active()  == True:
                self.cdrmedium = ""    
                self.cdrimage = "" 

            self.image_settings[self.currentimage] = {"emusystem" : self.emusystem
            , "machine": self.machine
            , "kqemu_param": store_kqemu_param
            , "bootmedium": self.bootmedium
            , "boot_driveletter": self.boot_driveletter
            , "cdrmedium": self.cdrmedium
            , "cdrimage": self.cdrimage
            , "hda_image": self.hda_image  
            , "hdb_image": self.hdb_image          
            , "hdc_image": self.hdc_image   
            , "hdd_image": self.hdd_image   
            , "fda_image": self.fda_image   
            , "fdb_image": self.fdb_image               
            , "soundhw": self.soundhw
            , "vgamode": self.vgamode
            , "usevnc": self.usevnc
            , "useusb": self.useusb
            , "novga": self.novga
            , "snapshotmode": self.snapshotmode
            , "localtimemode": self.localtimemode
            , "vncdisplay": self.vncdisplay
            , "memory": self.memory
            , "networkoptions": self.networkoptions
            , "customoptions": self.customoptions
            , "bootfromcd": self.bootfromcd
            , "networksetup" : self.networksetup
            , "networkmode" : self.networkmode
            , "networkredirs" : self.networkredirs
            , "network_hostname" : self.network_hostname
            , "usernetwork" : self.usernetwork
            , "smbsettings" : self.smbsettings
            }
            print "Settings for " + self.currentimage + ":"
            print self.image_settings[self.currentimage]
            storedata = self.image_settings
            filename = "image_settings"
            self.storetofile(storedata, filename)
            self.refresh_ilist()
            self.refresh_bookmarks()
            #self.refresh_machineslist()
            self.label_imgsettings.set_markup(_('<b>Stored Settings for Current selected image</b>'))
            
        #except:
        else:
            print "no image selected"
        #    print "no settings stored "
        self.button_apply_imagesettings.set_sensitive(False)
        self.button_restore_imagesettings.set_sensitive(False)

    def delete_event(self, widget, event, data=None):
        
        self.doexit = True
        self.dorun = False
        time.sleep(0.5)
        print "exit"
        gtk.main_quit()
        #self.destroy()
        exit
        return False
    
    def destroy_event(self, widget, *event):
        print "exit"
        gtk.main_quit()
        exit    
        return False    
        
    def button1_event(self, event):    
        pass
        
     

    def button2_event(self, event):
        pass
        
    def button3_event(self, event):
        pass
    
    ## performs all actions when selecting an image
    def select_bootimage(self, widget):
        active = widget.get_active()
        model = widget.get_model()
        row = model[active]
        item = row[0]
        self.bootmedium = item
        if self.bootmedium != "hda":
            self.combobox_hda.set_sensitive( True );   

        if self.bootmedium != "fda":
            self.combobox_fda.set_sensitive( True );          
        
        if self.bootmedium == "hda":
            self.boot_driveletter = "c"
            self.activate_xtracdrom(True)      
            self.combobox_hda.set_active( 0 );
            self.combobox_hda.set_sensitive( False );      
        elif self.bootmedium == "cdrom":            
            self.boot_driveletter = "d"
            self.activate_xtracdrom(False) 
        elif self.bootmedium == "fda":            
            self.boot_driveletter = "a"
            self.activate_xtracdrom(True) 
            self.combobox_fda.set_active( 0 );
            self.combobox_fda.set_sensitive( False );    
        else:
            self.boot_driveletter = "c"
            self.activate_xtracdrom(True) 
        #print "-" + self.bootmedium + " -boot " + self.boot_driveletter
        self.button_apply_imagesettings.set_sensitive(True)
        self.button_restore_imagesettings.set_sensitive(True)
    ## perform gui actions when using of extra cdrom device is not possible
    ## in current configuration
    def no_xtracdrom(self, widget):
        active = widget.get_active()
        #print "no xtracd"
        if active == True:
                    self.combobox_cdromdrive.set_sensitive( False );
                    self.combobox_imagecdrom.set_sensitive( False );
                    self.cdrimage = ""
                    self.cdrmedium = ""
    ## Set Variables and perform gui actions when changing "combobox_cdromdrive"
    def select_mountcdrom(self, widget):
        active = widget.get_active()

        #print "CDR-Drive %s" %active
        if active == True:
            print "CDR-Drive %s" %active
            self.combobox_cdromdrive.set_sensitive( True );
            self.combobox_imagecdrom.set_sensitive( False );
            self.cdrimage = ""
        self.button_apply_imagesettings.set_sensitive(True)     
        self.button_restore_imagesettings.set_sensitive(True)       
        
    def select_imagecdrom(self, widget):
        active = widget.get_active()
        #print "CDR-image %s" %active    
        if active == True:
            print "CDR-image %s" %active    
            self.combobox_cdromdrive.set_sensitive( False );
            self.combobox_imagecdrom.set_sensitive( True );
            self.cdrmedium = ""
        self.button_apply_imagesettings.set_sensitive(True)
        self.button_restore_imagesettings.set_sensitive(True)
        
    def select_cdromdrive(self, widget):
        active = widget.get_active()
        model = widget.get_model()
        row = model[active]
        item = row[0]
        #print "CDR auswahl " + item   
        settings = self.settings["cdromdrives"]
        #print "settings " + str(settings )
        #print "CDR medium choice: " + item
        self.cdrmedium = item
        print "CDR medium choice: " + self.cdrmedium
        self.button_apply_imagesettings.set_sensitive(True)
        self.button_restore_imagesettings.set_sensitive(True)
        
    def select_cdromimage(self, widget):
        active = widget.get_active()
        model = widget.get_model()
        row = model[active]
        item = row[0]
        self.cdrimage = item
        print "image CDR choice %s" %self.cdrimage
        self.button_apply_imagesettings.set_sensitive(True)
        self.button_restore_imagesettings.set_sensitive(True)
        
    def select_hda_image(self, widget):
        active = widget.get_active()
        model = widget.get_model()
        row = model[active]
        item = row[0]
        self.hda_image = item
        print "hda image choice %s" %self.cdrimage     
        self.button_apply_imagesettings.set_sensitive(True)
        self.button_restore_imagesettings.set_sensitive(True)
     
    def select_hdb_image(self, widget):
        active = widget.get_active()
        model = widget.get_model()
        row = model[active]
        item = row[0]
        self.hdb_image = item
        print "hdb image choice %s" %self.cdrimage   
        self.button_apply_imagesettings.set_sensitive(True)
        self.button_restore_imagesettings.set_sensitive(True)
        
    def select_hdc_image(self, widget):
        active = widget.get_active()
        model = widget.get_model()
        row = model[active]
        item = row[0]
        self.hdc_image = item
        print "hdc image choice %s" %self.cdrimage    
        self.button_apply_imagesettings.set_sensitive(True)    
        self.button_restore_imagesettings.set_sensitive(True)  
        
    def select_hdd_image(self, widget):
        active = widget.get_active()
        model = widget.get_model()
        row = model[active]
        item = row[0]
        self.hdd_image = item
        print "hdd image choice %s" %self.cdrimage     
        self.button_apply_imagesettings.set_sensitive(True)   
        self.button_restore_imagesettings.set_sensitive(True)
        
    def select_xtra_image(self, widget):
        wname = widget.get_name()
        active = widget.get_active()
        model = widget.get_model()
        row = model[active]
        item = row[0]
        
        if wname == 'combobox_hda':
            self.hda_image = item
            print "change hda to: " + str(self.hda_image)
            self.filechooserbutton_hda.set_filename(self.hda_image)

        if wname == 'combobox_hdb':
            self.hdb_image = item
            self.filechooserbutton_hdb.set_filename(self.hdb_image)   
        if wname == 'combobox_hdc':
            self.hdc_image = item        
            self.filechooserbutton_hdc.set_filename(self.hdc_image)  
        if wname == 'combobox_hdd':
            self.hdd_image = item 
            self.filechooserbutton_hdd.set_filename(self.hdd_image)   
        if wname == 'combobox_fda':
            self.fda_image = item    
            self.filechooserbutton_fda.set_filename(self.fda_image)
        if wname == 'combobox_fdb':
            self.fdb_image = item    
            self.filechooserbutton_fdb.set_filename(self.fdb_image)                                      
       
    def load_xtra_image(self, widget):
        wname = widget.get_name()
        try:
            active = widget.get_active()
            model = widget.get_model()
            row = model[active]
            item = row[0]
        except:
            item = widget.get_filename()
        #self.hdd_image = item
        print "widget name: " + str(wname)
        #if wname == 'combobox_hda':
        #    self.hda_image = item
        #    self.filechooserbutton_hda.set_filename(self.hda_image)
        #    tooltips.set_tip(self.eventbox_filechooserbutton_hda, str(self.hda_image))
        #    try:
        #        actct_hda = self.search_combolist(self.combobox_hda, self.hda_image)
        #        self.combobox_hda.set_active(actct_hda)    
        #    except:
        #        self.combobox_hda.set_active(0)      
        
        #if wname == 'combobox_hdb':
        #    self.hdb_image = item  
        #    self.filechooserbutton_hdb.set_filename(self.hdb_image)
        #    tooltips.set_tip(self.eventbox_filechooserbutton_hdb, str(self.hdb_image))
        #    try:
        #        actct_hdb = self.search_combolist(self.combobox_hdb, self.hdb_image)
        #        self.combobox_hdb.set_active(actct_hdb)    
        #    except:
        #        self.combobox_hdb.set_active(0)              
        #if wname == 'combobox_hdc':
        #    self.hdc_image = item  
        #    self.filechooserbutton_hdc.set_filename(self.hdc_image)
        #    tooltips.set_tip(self.eventbox_filechooserbutton_hdc, str(self.hdc_image))
        #    try:
        #        actct_hdc = self.search_combolist(self.combobox_hdc, self.hdc_image)
        #        self.combobox_hdc.set_active(actct_hdc)    
        #    except:
        #        self.combobox_hdc.set_active(0)             
        #if wname == 'combobox_hdd':
        #    self.hdd_image = item  
        #    self.filechooserbutton_hdd.set_filename(self.hdd_image)
        #    tooltips.set_tip(self.eventbox_filechooserbutton_hdd, str(self.hdd_image))
        #    try:
        #        actct_hdd = self.search_combolist(self.combobox_hdd, self.hdd_image)
        #        self.combobox_hdd.set_active(actct_hdd)    
        #    except:
        #        self.combobox_hdd.set_active(0)              
        #if wname == 'combobox_fda':
        #    self.fda_image = item  
        #    cdrpath = self.cdrom_path_by_name(self.fda_image)
        #    if cdrpath != "None":
        #        self.fda_image = cdrpath
        #    self.filechooserbutton_fda.set_filename(self.fda_image)
        #    tooltips.set_tip(self.eventbox_filechooserbutton_fda, str(self.fda_image))
        #    try:
        #        actct_fda = self.search_combolist(self.combobox_fda, self.fda_image)
        #        self.combobox_fda.set_active(actct_fda)    
        #    except:
        #        self.combobox_fda.set_active(0)                  
        #if wname == 'combobox_fdb':
        #    self.fdb_image = item    
        #    cdrpath = self.cdrom_path_by_name(self.fdb_image)
        #    if cdrpath != "None":
        #        self.fdb_image = cdrpath  
        #    self.filechooserbutton_fdb.set_filename(self.fdb_image)
        #    tooltips.set_tip(self.eventbox_filechooserbutton_fdb, str(self.fdb_image))
        #    try:
        #        actct_fdb = self.search_combolist(self.combobox_fdb, self.fdb_image)
        #        self.combobox_fdb.set_active(actct_fdb)    
        #    except:
        #        self.combobox_fdb.set_active(0)                   
                
        if wname == 'filechooserbutton_hda':
            self.hda_image = item
            #self.filechooserbutton_hda.set_filename(self.hda_image)
            tooltips.set_tip(self.eventbox_filechooserbutton_hda, str(self.hda_image))
            try:
                actct_hda = self.search_combolist(self.combobox_hda, self.hda_image)
                self.combobox_hda.set_active(actct_hda)    
            except:
                pass
            #    self.combobox_hda.set_active(0)
            #print "image for hda: " + str(self.hda_image)
        if wname == 'filechooserbutton_hdb':
            self.hdb_image = item 
            tooltips.set_tip(self.eventbox_filechooserbutton_hdb, str(self.hdb_image))
            try:
                actct_hdb = self.search_combolist(self.combobox_hdb, self.hdb_image)
                self.combobox_hdb.set_active(actct_hdb)    
            except:
                pass
                #self.combobox_hdb.set_active(0)             
        if wname == 'filechooserbutton_hdc':
            self.hdc_image = item  
            tooltips.set_tip(self.eventbox_filechooserbutton_hdc, str(self.hdc_image))
            try:
                actct_hdc = self.search_combolist(self.combobox_hdc, self.hdc_image)
                self.combobox_hdc.set_active(actct_hdc)    
            except:
                pass
                #self.combobox_hdc.set_active(0)             
        if wname == 'filechooserbutton_hdd':
            self.hdd_image = item 
            tooltips.set_tip(self.eventbox_filechooserbutton_hdd, str(self.hdd_image))
            try:
                actct_hdd = self.search_combolist(self.combobox_hdd, self.hdd_image)
                self.combobox_hdd.set_active(actct_hdd)    
            except:
                pass
                #self.combobox_hdd.set_active(0)  
        if wname == 'filechooserbutton_fda':
            self.fda_image = item  
            tooltips.set_tip(self.eventbox_filechooserbutton_fda, str(self.fda_image))
            try:
                actct_fda = self.search_combolist(self.combobox_fda, self.fda_image)
                self.combobox_fda.set_active(actct_fda)    
            except:
                pass
                #self.combobox_fda.set_active(0)
                
        if wname == 'filechooserbutton_fdb':
            self.fdb_image = item    
            tooltips.set_tip(self.eventbox_filechooserbutton_fdb, str(self.fdb_image))
            try:
                actct_fdb = self.search_combolist(self.combobox_fdb, self.fdb_image)
                self.combobox_fdb.set_active(actct_fdb)    
            except:
                pass
                #self.combobox_fdb.set_active(0)                  
                      
        self.button_apply_imagesettings.set_sensitive(True) 
        self.button_restore_imagesettings.set_sensitive(True)
        
    def select_emusystem(self, widget):
        active = widget.get_active()
        model = widget.get_model()
        row = model[active]
        item = row[0]
        self.emusystem = item
        print "emusystem: %s choosen" %self.emusystem   
        self.qemubin = self.emusystem_path_by_name(self.emusystem)
        self.get_soundhw()
        self.refresh_soundhw() 
        
        self.get_machine()
        self.refresh_machineslist()
        
        self.button_apply_imagesettings.set_sensitive(True)    
        self.button_restore_imagesettings.set_sensitive(True)        
        
    def select_machine(self, widget):
        active = widget.get_active()
        model = widget.get_model()
        row = model[active]
        item = row[0]
        self.machine = item
        self.machinecommand = self.machine_path_by_name(self.machine)
        print "machine: %s choosen" %self.machine   
        self.get_soundhw()
        #self.refresh_machineslist() 
        
        self.button_apply_imagesettings.set_sensitive(True)    
        self.button_restore_imagesettings.set_sensitive(True)       

    def select_soundhw(self, widget):
        active = widget.get_active()
        model = widget.get_model()
        row = model[active]
        item = row[0]
        self.soundhw = item
        print "soundhw %s" %self.soundhw    
        self.button_apply_imagesettings.set_sensitive(True)    
        self.button_restore_imagesettings.set_sensitive(True)

    def set_vgamode(self, *widget):
        if self.checkbutton_usevga.get_active() == True:
                self.vgamode = "std-vga"
        else:
                self.vgamode = "default"
        self.button_apply_imagesettings.set_sensitive(True)
        self.button_restore_imagesettings.set_sensitive(True)
        
    def set_novga(self, *widget):
        self.novga = self.checkbutton_novga.get_active()
        print "No VGA state changed: " + str(self.novga)
        if self.novga == False:
            #self.checkbutton_usevga.set_active(True)
            self.checkbutton_usevga.set_sensitive(True)
            #self.checkbutton_startvnc.set_active(True)
            self.checkbutton_startvnc.set_sensitive(True)
        else:
            self.checkbutton_usevga.set_active(False)
            self.checkbutton_usevga.set_sensitive(False)
            self.checkbutton_startvnc.set_active(False)
            self.checkbutton_startvnc.set_sensitive(False)    
            
        self.button_apply_imagesettings.set_sensitive(True)
        self.button_restore_imagesettings.set_sensitive(True)        
                
    def set_startvnc(self, *widget):
        if self.checkbutton_startvnc.get_active() == True:
                self.usevnc = "vnc"
                print self.usevnc + " at " + str(self.vncdisplay)
        else:
                self.usevnc = "novnc"  
                print self.usevnc
        self.button_apply_imagesettings.set_sensitive(True)
        self.button_restore_imagesettings.set_sensitive(True)
        
    def set_bootfromcd(self, *widget):

        self.bootfromcd = self.checkbutton_bootcdrom.get_active()
        print "Boot from CD: " + str(self.bootfromcd)
        self.button_apply_imagesettings.set_sensitive(True)
        self.button_restore_imagesettings.set_sensitive(True)    
                
    def set_vncdisplay(self, *widget):
        self.vncdisplay = int(self.spinbutton_vncdisplay.get_value())
        print "changed vncdisplay to: " + str(self.vncdisplay)
        self.button_apply_imagesettings.set_sensitive(True)
        self.button_restore_imagesettings.set_sensitive(True)
        
    def set_memory(self, widget, *data):
        #time.sleep(0.2)
        #val = self.spinbutton_memory.Adjustment.get_value()
        #self.memory = int(val)
        #self.memory = int(self.spinbutton_memory.get_value())
        self.memory = self.spinbutton_memory.get_value_as_int()
        #self.memory = int(self.spinbutton_memory.get_input())
        #self.memory = self.spinbutton_memory.get_value()
        print "changed memory to: " + str(self.memory)
        #self.spinbutton_memory.set_value(self.memory)
        self.button_apply_imagesettings.set_sensitive(True)
        self.button_restore_imagesettings.set_sensitive(True)
        
    def set_usb(self, *widget):
        self.useusb = self.checkbutton_enable_usb.get_active()
        print "Use USB: " + str(self.useusb)
        self.button_apply_imagesettings.set_sensitive(True)
        self.button_restore_imagesettings.set_sensitive(True)
        
    def set_snapshotmode(self, *widget):
        self.snapshotmode = self.checkbutton_snapshotmode.get_active()
        print "Use snapshotmode: " + str(self.snapshotmode)
        self.button_apply_imagesettings.set_sensitive(True)
        self.button_restore_imagesettings.set_sensitive(True)    
        
    def set_localtimemode(self, *widget):
        self.localtimemode = self.checkbutton_localtime.get_active()
        print "Use localtime: " + str(self.localtimemode)
        self.button_apply_imagesettings.set_sensitive(True)
        self.button_restore_imagesettings.set_sensitive(True) 
        
    def set_network(self, widget):
        self.networkoptions = widget.get_text()
        print "Network options: " + str(self.networkoptions)
        self.button_apply_imagesettings.set_sensitive(True)
        self.button_restore_imagesettings.set_sensitive(True)      
        
    def set_defaultnet(self, widget):
        self.networkoptions = "-net nic,vlan=0 -net user,vlan=0,hostname=emu"
        self.entry_networkline.set_text(self.networkoptions)
        #self.networkoptions = defaultnetline
        print "Network options: " + str(self.networkoptions)
        self.button_apply_imagesettings.set_sensitive(True)
        self.button_restore_imagesettings.set_sensitive(True)      
     
    def set_customoptions(self, widget):
        self.customoptions = widget.get_text()
        print "Custom options: " + str(self.customoptions)
        self.button_apply_imagesettings.set_sensitive(True)
        self.button_restore_imagesettings.set_sensitive(True)      
                        

    def cdrom_path_by_name(self, name):
        settings = self.settings["cdromdrives"]
        path = "None"
        dev = "None"
        for setting in settings:
            if setting[0] == name:
                path = setting[1]
                #print "cdrom path for " + str(name) + ": " + str(path)
        return path
        
    def soundhw_path_by_name(self, name):
        settings = self.audio_devlist
        path = "None"
        for setting in settings:
            if setting[1] == name:
                dev = setting[0]
                #print "sounddev: " + dev
        return dev        
        
    def cdrom_name_by_path(self, path):
        settings = self.settings["cdromdrives"]
        path = "None"
        for setting in settings:
            if setting[1] == path:
                name = setting[0]
                #print "name: " + name
                #print "cdrom name for " + str(path) + ": " + str(name)
        return path
        
    def emusystem_path_by_name(self, name):
        settings = self.settings["qemuapps"]
        path = "None"
        for setting in settings:
            if setting[0] == name:
                path = setting[1]
                #print "path: " + path
        return path        
        
    def machine_path_by_name(self, name):
        settings = self.machineslist
        path = ""
        for setting in settings:
            #print "found: " + str(setting[0])
            if setting[1] == name:
                path = setting[0]
                print "machinecommand: " + str(path)
        return path         

    def set_nokqemu(self, widget):
        self.kqemu_param = "-no-kqemu"
        print self.kqemu_param
        self.button_apply_imagesettings.set_sensitive(True)
        self.button_restore_imagesettings.set_sensitive(True)
        
    def set_kqemu(self, widget):
        self.kqemu_param = ""
        print self.kqemu_param
        self.button_apply_imagesettings.set_sensitive(True)
        self.button_restore_imagesettings.set_sensitive(True)
    
    def set_kkqemu(self, widget):
        self.kqemu_param = "-kernel-kqemu"       
        print self.kqemu_param 
        self.button_apply_imagesettings.set_sensitive(True)
        self.button_restore_imagesettings.set_sensitive(True)
        
    def delete_openimagedialog(self):
        print "close filechooser"
        
    def fileChooser_emuimage(self, widget):
        
        dic = {"on_filechooserdialog_openimage_destroy" : self.delete_openimagedialog
        , "on_filechooserdialog_openimage_response" : self.fileChooser_emuimage_response
        }
        
        self.filechooserdialog_openimage = gtk.glade.XML(self.gladefile, "filechooserdialog_openimage", APP)
        self.filechooserdialog_openimage.signal_autoconnect(dic)

    def fileChooser_emuimage_response(self, widget, response, *entry):
        #print 'widget: ' + str(widget)
        #print 'response: ' + str(response)
        entrytext = widget.get_filename()
        #print 'entry: ' + entrytext
        if response == gtk.RESPONSE_OK:
            file = widget.get_filename ()
            widget.destroy ()
            print 'File selected: ' + file       
            self.set_currentimage(file)
            return file      
        elif response == gtk.RESPONSE_CANCEL:
            widget.destroy ()   
            return None               
        return None

    def activate_launchbuttons(self, switchstate):
            self.toolbutton_launch.set_sensitive( switchstate );
            self.toolbutton_launch_unmanaged.set_sensitive( switchstate );
            self.toolbutton_launchxterm.set_sensitive( switchstate );
            
    def activate_xtracdrom(self, switchstate):
            self.combobox_cdromdrive.set_sensitive( switchstate );
            self.combobox_imagecdrom.set_sensitive( switchstate );     
            self.radiobutton_cdromtype1.set_sensitive( switchstate );
            self.radiobutton_cdromtype2.set_sensitive( switchstate );     
            if switchstate == True:
                self.radiobutton_cdromtype.set_active( False );
            elif switchstate == False:
                self.radiobutton_cdromtype.set_active( True );                
    
 ## Function to prebuild the qemu network commands
    def qemu_network_command(self):    
        qemu_netcommand = " "
        if self.networkmode == "nonet":
            qemu_netcommand = " -net none"
        elif self.networkmode == "usermode" or self.networkmode == "":
            qemu_netcommand = self.usernetwork.create_qemucommand()
            #qemu_netcommand = " -net nic,vlan=0 -net user,vlan=0,hostname=" + self.network_hostname            
        elif self.networkmode == "custom":
            for netcard in self.networksetup:
                command = netcard.create_qemucommand()
                #qemu_netcommand = qemu_netcommand + command + " " 
                qemu_netcommand = qemu_netcommand + command
            for redir in self.networkredirs:
                command = redir.create_qemucommand()
                #qemu_netcommand = qemu_netcommand + command + " "
                qemu_netcommand = qemu_netcommand + command
                
        if self.networkmode != "nonet":
                command = self.smbsettings.create_qemucommand()
                #qemu_netcommand = qemu_netcommand + command + " "
                qemu_netcommand = qemu_netcommand + command
            
            
        print "network commandline: " + qemu_netcommand
        return qemu_netcommand
 ## Function to build the qemu command
    def qemu_command(self, rmode):
    
        #if self.soundhw != "" and self.soundhw != "None":
        #emusystem = self.emusystem_path_by_name(self.emusystem)
        #self.qemubin = self.emusystem_path_by_name(self.emusystem)
        #soundhwcommand = " -soundhw " + soundhw
        #else:
        #    soundhwcommand = ""
        machinecommand = ""
        if self.machinecommand != "":
            machinecommand = " -M " + self.machinecommand
        
        memorycommand = " -m " + str(self.memory)
        
        cdrcommand = ""        
        if self.cdrmedium != "" and self.cdrmedium != "None":
            cdrpath = self.cdrom_path_by_name(self.cdrmedium)
            cdrcommand = " -cdrom " + cdrpath
        elif self.cdrimage != "" and self.cdrimage != "None":
            self.cdrimage
            cdrcommand = " -cdrom " + self.cdrimage            

        soundhwcommand = ""  
        if self.soundhw != "" and self.soundhw != "None":
            soundhw = self.soundhw_path_by_name(self.soundhw)
            soundhwcommand = " -soundhw " + soundhw
            
        novgacommand = ""
        if self.novga == True:
            novgacommand = " -nographic"            
            
        vgacommand = ""
        if self.vgamode == "std-vga":
            vgacommand = " -std-vga"
             
        vnc_command = ""  
        if self.usevnc == "vnc":
            vnc_command = " -usbdevice tablet -vnc " + str(self.vncdisplay)              
             
        usb_command = ""
        if self.useusb == True:
            usb_command = " -usb" 
            
        snapsot_command = ""
        if self.snapshotmode == True:
            snapsot_command = " -snapshot"            
             
        localtime_command = ""
        if self.localtimemode == True:
            localtime_command = " -localtime"            
                          
        hda_command = ""
        if self.hda_image != None and self.hda_image != "None":
            hda_command = " -hda " + str(self.hda_image)
        hdb_command = ""
        if self.hdb_image != None and self.hdb_image != "None":
            hdb_command = " -hdb " + str(self.hdb_image)
        hdc_command = ""
        if self.hdc_image != None and self.hdc_image != "None":
            hdc_command = " -hdc " + str(self.hdc_image)          
        hdd_command = ""
        if self.hdd_image != None and self.hdd_image != "None":
            hdd_command = " -hdd " + str(self.hdd_image)
        fda_command = ""
        if self.fda_image != None and self.fda_image != "None":
            fda_command = " -fda " + str(self.fda_image)
        fdb_command = ""            
        if self.fdb_image != None and self.fdb_image != "None":
            fdb_command = " -fdb " + str(self.fdb_image)
        networkoptions = ""
        if self.networkoptions != "":
            networkoptions = self.networkoptions
        customoptions = ""
        if self.customoptions != "":
            customoptions = " " + self.customoptions      
        #print "self.boot_driveletter: " + str(self.boot_driveletter)
        #if self.bootfromcd == True:
        #    bootdriveletter = "d"
            #print "cdboot: " + str(self.bootfromcd)
        #else:
        bootdriveletter = self.boot_driveletter
        monitor_command = " -monitor pty"
        
        netcommand = self.qemu_network_command()
        
        #qemucommand = "qemu " + self.kqemu_param + networkoptions + usb_command + vgacommand + soundhwcommand + vnc_command + customoptions + cdrcommand + hda_command + hdb_command + hdc_command + hdd_command + fda_command + fdb_command +" -" + self.bootmedium + " " + self.currentimage + " -boot " + bootdriveletter + "&"
        basecommand = self.qemubin + machinecommand + memorycommand + snapsot_command + localtime_command + " " + self.kqemu_param + netcommand + usb_command + vgacommand + novgacommand + soundhwcommand + vnc_command + customoptions + cdrcommand + hda_command + hdb_command + hdc_command + hdd_command + fda_command + fdb_command
        print "qemu run mode: " + str(rmode)
        try:
            if rmode== "managed":
                qemucommand =  basecommand + monitor_command + " -" + self.bootmedium  + " " + self.currentimage + " -boot " + bootdriveletter
            else:
                qemucommand = basecommand + " -" + self.bootmedium  + " " + self.currentimage + " -boot " + bootdriveletter
        except:
            qemucommand = basecommand + " -" + self.bootmedium  + " " + self.currentimage + " -boot " + bootdriveletter
            
        print "Qemu command: " + str(qemucommand)
        return qemucommand
        
    ## Function to launch qemu directly
    def run_qemu(self, widget):
        #print "command: " + self.qemu_command()
        print "-------------------------Run Qemu--------------------------------------"
        mode = 'managed'
        command = self.qemu_command(mode)
        child_stdout, child_stdin, child_stderr = os.popen3(command)
        qemumonout = QemuOutThread(child_stdout, child_stderr)
        qemumonout.start()   
        time.sleep(0.5)
        maxtry = 20
        trycount = 1
        print "Looking for the launched pts terminal..."
        while trycount < maxtry:
            try:
                self.currentpts = qemumonout.currentpts
                print "Used pts device: " + str(self.currentpts)
                break
            except:
                #print "waiting for pts answer " + str(trycount) + " " + str(maxtry)
                time.sleep(0.5)
                trycount = trycount+1
        #print "vergleich " + str(trycount) + " " + str(maxtry)                
        if trycount == maxtry:
            print "timeout!"
            #message = "No qemu session started or\n\
#the launched process did't return a valid\n\
#pts console to communicate with. Monitoring not activated.\n\
#if qemu don't start, try runnning the job in xterm\n\
#to see qemu error message."
            message = _('No qemu session started or\n the launched process didt return a valid\n\
pts console to communicate with. Monitoring not activated.\n\
if qemu don´t start, try runnning the job in xterm\n\
to see qemu error message.')
            title = _('Warning!')
            self.init_messages_dialog(message, *title)
        else:
            #ptsin = PtsWrite(self.currentpts, "info usbhost")
            #ptsin.start()   
            ptsmon = QemuPtsThread(self, self.currentpts, self.currentimage).start()
         
    def run_qemu_unmanaged(self, widget):
        #print "command: " + self.qemu_command()
        #os.popen("xterm -e %s" %self.qemu_command())
        #newpty = os.openpty()
        #print "pty: " + str(newpty)
        
        os.popen(self.qemu_command("unmanaged") + "&")         
         
    ## Function to launch qemu in xterm
    def run_qemu_xterm(self, widget):
        #print "command: " + self.qemu_command()
        #os.popen("xterm -e %s" %self.qemu_command())
        #newpty = os.openpty()
        #print "pty: " + str(newpty)
        
        os.popen("xterm -hold -e %s &" %self.qemu_command("unamanged"))
        
#########################################
## Functions for the settings dialog        
    def create_model_cdromdrives(self, data):
        store = gtk.ListStore(gobject.TYPE_STRING,
                          gobject.TYPE_STRING)
        for item in data:
            iter = store.append()
            itempath = item[0]
            itemname = item[1]
            #print itempath
            #print itemname
            store.set(iter, 0, item[0], 1, item[1])
        return store    

    def add_columns_cdromdrives(self, treeview, model):
    
        renderer = gtk.CellRendererToggle()
        column = gtk.TreeViewColumn(_('Name'), gtk.CellRendererText(), text=0)
        column2 = gtk.TreeViewColumn(_('Device'), gtk.CellRendererText(), text=1)
        treeview.append_column(column)   
        treeview.append_column(column2) 
        
    def check_haveconfig(self, bootimage):
        haveconfig = False
        try:
            if self.image_settings[bootimage]:
                #print "Config for " + str(bootimage) + " found"
                haveconfig = True
            else:
                #print "No config for " + str(bootimage) + " found"
                haveconfig = False
        except:       
            #print "No config for " + str(bootimage) + " found"
            haveconfig = False
        return haveconfig
        
    def load_bookmarks(self, *widget):
        self.bookmarks = []
        try:
            outdata = self.getfromfile("bookmarks")
            if outdata  == { } or outdata == "":
                #self.bookmarks = [("keine Bookmarks", "")]
                #self.bookmarks = []
                bookmarks = []
            else:
                #self.bookmarks = outdata
                bookmarks = outdata
        except:
            #self.bookmarks = [("keine Bookmarks", "")]
            #self.bookmarks = []
            bookmarks = []
            
        #if self.bookmarks != []:
        if bookmarks != []:
            #print "old bookmarks: " + str(bookmarks)
            #self.bookmarks = []
            for entry in bookmarks:
                #haveconfig = False
                #itemicon = ""
                #itemname = ""
                #itempath = ""                   
                #isoldconfig = False                
                try:
                    if len(entry) == 4:
                        itemicon = entry[0]
                        itemname = entry[1]
                        itempath = entry[2] 
                        isoldconfig = True                 
                    elif len(entry) == 3 or len(entry) == 2:
                        itemicon = self.default_machine_icon
                        itemname = entry[0]
                        itempath = entry[1] 
                        isoldconfig = True
                except:
                    itemicon = entry.icon
                    itemname = entry.name
                    itempath = entry.path  
                                      
                    isoldconfig = False
                    
                haveconfig = self.check_haveconfig(itempath)
                
                if isoldconfig == True:
                    #haveconfig = self.check_haveconfig(itempath)
                    #pathstring = pathstring + "\n config: something"
                    self.bookmarks.append((itemicon, itemname, itempath, haveconfig))
                    print "have configuration: " + str(haveconfig)
                else:
                    entry.haveconfig = haveconfig
                    #entry.path = entry.path + "\n config: something" 
                    self.bookmarks.append(entry)
            #print "bookmarks: " + str(self.bookmarks)
            
        #model = self.create_model_bookmarks(self.bookmarks)
        try:
            model = self.treeview_bookmarks.get_model()
            model.clear()
            model = self.create_model_bookmarks(self.bookmarks)
            self.treeview_bookmarks.set_model(model)
        except:
            model = self.create_model_bookmarks(self.bookmarks)
            self.treeview_bookmarks.set_model(model)
            self.add_columns_bookmarks(self.treeview_bookmarks, model)
        #try:
            #self.treeview_bookmarks.clear()
        #    model.clear()
        #except:
        #    pass
        #self.treeview_bookmarks.set_model(model)
        #self.add_columns_bookmarks(self.treeview_bookmarks, model) 
        
#def get_icon_pixbuf(self, stock):
    # Use any technique you like to return a pixbuf to be stored
    # in the model.  We use render_icon() only because we want
    # stock icons for this example.
    #return self.render_icon(stock_id=getattr(gtk, stock), 
    #                        size=gtk.ICON_SIZE_MENU, 
     #                       detail=None)          
   
    def create_model_bookmarks(self, data):
        store = gtk.ListStore(gtk.gdk.Pixbuf,
                          gobject.TYPE_STRING,
                          gobject.TYPE_STRING,
                          gtk.gdk.Pixbuf)
        
        config_icon = gtk.Image()
        #Pixbuf = config_icon.get_pixbuf()
        for item in data:
            #haveconfig = False
            iter = store.append()
            try:
                if len(item) == 4:
                    itemicon = item[0]
                    itemname = item[1]
                    itempath = item[2]
                    haveconfig = item[3] 
                    isoldconfig = True                 
                elif len(item) == 3:
                    itemicon = self.default_machine_icon
                    itemname = item[0]
                    itempath = item[1] 
                    haveconfig = item[2]
                    isoldconfig = True  
                print "load old bookmark"              
            except:
                itemicon = str(item.icon)
                itemname = str(item.name)
                itempath = str(item.path)
                haveconfig = item.haveconfig 
                modeldata = item.get_modeldata() 
                #print "modeldate: " + str(modeldata)
                isoldconfig = False
                #print "load new bookmark"  
            #print "haveconfig: " + str(haveconfig)
            
            system_icon = gtk.gdk.pixbuf_new_from_file(itemicon)
            if isoldconfig == False:
                config_icon = modeldata[3]
            else:
                if haveconfig == True:
                    config_icon = gtk.gdk.pixbuf_new_from_file('pixmaps/gtk-yes.png')
                else:
                    config_icon = gtk.gdk.pixbuf_new_from_file('pixmaps/gtk-no.png')
            #print "haveconfig: " + str(haveconfig) + " icon: " + str(config_icon) + "for item: " + str(itempath)
       
            store.set(iter, 0, system_icon.scale_simple(int(self.default_iconsize),int(self.default_iconsize),3), 1, itemname, 2, itempath, 3, config_icon)
        return store  
   
    def add_columns_bookmarks(self, treeview, model):
    
        renderer = gtk.CellRendererToggle()
        column_icon = gtk.TreeViewColumn(_('Icon'), gtk.CellRendererPixbuf(), pixbuf=0)
        column = gtk.TreeViewColumn(_('Name'), gtk.CellRendererText(), text=1)
        column2 = gtk.TreeViewColumn(_('Boot image'), gtk.CellRendererText(), text=2)
        column3 = gtk.TreeViewColumn(_('configured'), gtk.CellRendererPixbuf(), pixbuf=3)
        treeview.append_column(column_icon)
        treeview.append_column(column)   
        treeview.append_column(column2)  
        treeview.append_column(column3)
        
    def create_model_joblist(self, data):
        store = gtk.ListStore(gobject.TYPE_STRING,
                          gobject.TYPE_STRING,
                          gobject.TYPE_STRING)
        data.sort()
        for item in data:
            if item != 0:
                iter = store.append()
                itempath = item[0]
                itemname = item[1]
                itemrunstat = item[2]
                #print itempath
                #print itemname
                #print itemrunstat
                store.set(iter, 0, item[0], 1, item[1], 2, item[2])
        return store  
   
    def add_columns_joblist(self, treeview, model):
    
        renderer = gtk.CellRendererToggle()
        column = gtk.TreeViewColumn(_('Path'), gtk.CellRendererText(), text=0)
        column2 = gtk.TreeViewColumn(_('monitor pseudo terminal'), gtk.CellRendererText(), text=1)
        column3 = gtk.TreeViewColumn(_('running'), gtk.CellRendererText(), text=2)
        treeview.append_column(column)   
        treeview.append_column(column2)      
        treeview.append_column(column3)    
    
    def load_joblist(self, *widget):
        
        
        model = self.create_model_joblist([])            

        #try:
        #    self.treeview_joblist.clear()
        #except:
        #    pass
        self.treeview_joblist.set_model(model)
        self.add_columns_joblist(self.treeview_joblist, model)   
        
        if os.path.exists("config/joblist"):
            self.joblist_data = self.getfromfile("joblist")
        else:
            self.joblist_data = []
        try:
            self.joblist_data.sort()
        except:
            pass
        joblist_data = deepcopy(self.joblist_data)
        try:
            if self.joblist_data  == [] or self.joblist_data == "":
                #self.bookmarks = [("keine Bookmarks", "")]
                self.joblist_data = ""
                #print "-------------------------------------------------"
                print "no running jobs found"
                self.storetofile(self.joblist_data, "joblist")
                #print "-------------------------------------------------"
            else:
                #print "-------------------------------------------------"
                print "running jobs found"
                #print "-------------------------------------------------"
                jc = 0                
                for job in joblist_data:
                    time.sleep(0.3)
                    path = job[0]
                    pts = job[1]
                    runstat = job[2]
                    if os.path.exists(pts):
                        #self.joblist_data.remove((path, pts, runstat))
                        #self.joblist_data[jc] = 0
                        del self.joblist_data[jc]
                        ptsmon = QemuPtsThread(self, pts, path, runstat).start()
                        time.sleep(0.3)

                    else:
                        #self.joblist_data.remove((path, pts, runstat))   
                        #self.joblist_data[jc] = 0    
                        del self.joblist_data[jc]
                    jc = jc+1     

        except:
            #self.bookmarks = [("keine Bookmarks", "")]
            #print "-------------------------------------------------"
            print "running jobs found"
            #print "-------------------------------------------------"
            #if job
            jc = 0
            for job in joblist_data:
                #print "------jobload-------------------------------------"
                print str(job)
                if job != 0:
                    time.sleep(0.3)
                    path = job[0]
                    pts = job[1]
                    runstat = job[2]
                    if os.path.exists(pts):
                        #self.joblist_data.remove((path, pts, ))
                        #self.joblist_data.remove[jc]
                        #self.joblist_data[jc] = 0
                        del self.joblist_data[jc]
                        ptsmon = QemuPtsThread(self, pts, path).start()
                    else:
                        #self.joblist_data.remove((path, pts, ))
                        #self.joblist_data.remove(jc)
                        #self.joblist_data.remove[jc]
                        #self.joblist_data[jc] = 0
                        del self.joblist_data[jc]
                else:
                    pass
                jc = jc+1
            
        self.storetofile(self.joblist_data, "joblist")
    
        
    def refresh_joblist(self, *widget):    
        #ilistmodel = self.isolist.get_model() 
        data=self.joblist_data
        data.sort()
        ilistmodel = self.create_model_joblist(data)    
        self.treeview_joblist.set_model(ilistmodel)        
        
    def add_job(self, path, pts, runstat="1"):
        #print 'widget: ' + str(widget)
        #print 'response: ' + str(response)
        
        print 'Bootimage of the job: ' + path
        print 'Used pts: ' + pts

        try:
            self.joblist_data.append((path, pts, runstat))
        except:
            self.joblist_data = [(path, pts, runstat)]

        model = self.treeview_joblist.get_model()
        model.append(row=(path, pts, runstat))
        self.storetofile(self.joblist_data, "joblist")
        #print str(self.joblist_data)
        #return entryname      
        
    def remove_job(self, path, pts, runstat):
        entry_pts = pts
        #print 'widget: ' + str(widget)
        print 'remove entry: ' + str(entry_pts)
        entryindex = self.search_job(self.treeview_joblist, str(pts), "index")
        #entry_name = self.search_job(self.treeview_joblist, str(entry_pts), "pts")
        entry_path = path

        if entryindex != "None":
            model = self.treeview_joblist.get_model()
            selectIter = model.get_iter(entryindex)
            #print str(selectIter)
            #print "entryindex" + str(entryindex)
            model.remove(selectIter)
            #self.joblist_data.remove((path, pts, runstat))
            #self.joblist_data[entryindex] = 0
            del self.joblist_data[entryindex]
            #self.button_remove_bookmark.set_sensitive(False)
            #self.entry_current_image.set_text("")
        else:
            print "no enty " + str(entry_path)  + " found"

        self.storetofile(self.joblist_data, "joblist")
        print self.joblist_data
        #return str(entry_name)      
      
    def search_job(self, widget, searchstring, returnval):
        ct = 0
        outct = "None"
        bmmodel = widget.get_model()
        #print "bmmodel: " + str(bmmodel)
        for row in bmmodel:

            if searchstring == row[1]:
                #print "brow: " + row[0]
                #print "bct: " + str(ct)
                if returnval == "index":
                    outct = ct
                else:
                    outct = row[0]
                
            ct = ct + 1      
        print "job search result: " + str(outct)            
        return outct        
         
    
        
    #def bookmark_selection(self, widget, path, *view_column):
    def bookmark_selection(self, widget):
        #print "widget: " + str(widget)
        #print "path: " + str(path)
        #print "view_column: " + str(view_column)
        model, iter = widget.get_selection().get_selected()
        row = model[iter]
        item = row[2]
        print "selected bookmark : %s" %item
        self.set_currentimage(item)        
        
    def add_bookmark(self, widget, *event):
        GoOn = False
        mode = "add"
        menuitem = widget.get_name()
        print "menuitem: " + str(menuitem)
        if menuitem == "item_bookmark" or menuitem == "button_add_bookmark":
            mode = "add"
            response = self.add_bookmark_response
        if menuitem == "item_edit_bookmark":
            mode = "edit"
            response = self.edit_bookmark_response
            
        self.dialog_bookmarks = gtk.glade.XML(self.gladefile, "dialog_bookmarks", APP)
        self.dialog_bookmarks_widget = self.dialog_bookmarks.get_widget("dialog_bookmarks")
        if mode == "edit":
            try:
                self.dialog_bookmarks_widget.set_title("Edit selected Machine entry")
                model, iter = self.treeview_bookmarks.get_selection().get_selected()
                counter = int(model.get_string_from_iter(iter))
                print "counter: " + str(counter)
                self.bookmark_tmpitem = self.bookmarks[counter]
                try:
                    name = self.bookmark_tmpitem.name
                    inpath = self.bookmark_tmpitem.path
                    icon = self.bookmark_tmpitem.icon
                except:
                    name = self.bookmark_tmpitem[1]
                    inpath = self.bookmark_tmpitem[2]
                    icon = path.abspath(self.bookmark_tmpitem[0])  
                    if icon == "":
                        icon = path.abspath(self.default_machine_icon)                
                    
                print "name: " + str(name)
                print "icon: " + str(icon)
                #self.tmpredir = self.network_editredir   
                GoOn = True             
            except:
                print "No machine selected"
                GoOn = False        
        else:
            try:
                inpath = self.currentimage
                GoOn = True
            except:
                print "No item selected"
                GoOn = False
        #print "b event: " + str(event)
        #if self.selected_image != "":
        #    inpath = self.selected_image
        if GoOn != False:
            Name_field = self.dialog_bookmarks.get_widget("entry_bookmark_name")
            Path_field = self.dialog_bookmarks.get_widget("entry_bookmark_path")
            filechooserbutton_machine_icon = self.dialog_bookmarks.get_widget("filechooserbutton_machine_icon")
            
            
            Path_field.set_text(inpath)
            if mode == "edit":
                Name_field.set_text(name)
                #iconpath = path.abspath(icon)
                iconpath = str(icon)                
            else:
                iconpath = path.abspath(self.default_machine_icon)                
                #iconpath = path.abspath(icon)
                #iconpath = str(icon)
            filechooserbutton_machine_icon.set_filename(iconpath)
            
            
            
            
            
            Name = Name_field.get_text()
            Path = Path_field.get_text()
            
            dic = {"on_dialog_bookmarks_response" : response,
            }
            self.dialog_bookmarks.signal_autoconnect(dic)
        
    #def add_bookmark_list(self, widget, *event):
    #    self.dialog_bookmarks = gtk.glade.XML(self.gladefile, "dialog_bookmarks", APP)
    #    #inpath = self.currentimage
    #    #print "b event: " + str(event)
    #    #if self.selected_image != "":
    #    inpath = self.selected_image
        
    #    Name_field = self.dialog_bookmarks.get_widget("entry_bookmark_name")
    #    Path_field = self.dialog_bookmarks.get_widget("entry_bookmark_path")
    #    Path_field.set_text(inpath)
        
    #    filechooserbutton_machine_icon = self.dialog_bookmarks.get_widget("filechooserbutton_machine_icon")
    #    iconpath = path.abspath(self.default_machine_icon)
    #    filechooserbutton_machine_icon.set_filename(iconpath)        
        
    #    Name = Name_field.get_text()
    #    Path = Path_field.get_text()
        
    #    dic = {"on_dialog_bookmarks_response" : self.add_bookmark_response,
    #    }
    #    self.dialog_bookmarks.signal_autoconnect(dic)        
        
        
        
    def add_bookmark_response(self, widget, response, *entry):
        #print 'widget: ' + str(widget)
        #print 'response: ' + str(response)
        entryname = self.dialog_bookmarks.get_widget("entry_bookmark_name")
        entrypath = self.dialog_bookmarks.get_widget("entry_bookmark_path")
        filechooserbutton_machine_icon = self.dialog_bookmarks.get_widget("filechooserbutton_machine_icon")
        
        entry_icon = str(filechooserbutton_machine_icon.get_filename())
        entry_icon_pixbuf = gtk.gdk.pixbuf_new_from_file(entry_icon)
        
        entry_name = str(entryname.get_text())
        entry_path = str(entrypath.get_text())
        haveconfig = str(self.check_haveconfig(entry_path))
        if haveconfig == True:
            config_icon = gtk.gdk.pixbuf_new_from_file('pixmaps/gtk-yes.png')
        else:
            config_icon = gtk.gdk.pixbuf_new_from_file('pixmaps/gtk-no.png')
        #print 'entryname: ' + entry_name
        #print 'entrypath: ' + entry_path
        if response == gtk.RESPONSE_OK:
            
            newbookmark = Bookmark()
            newbookmark.icon = entry_icon
            newbookmark.name = entry_name
            newbookmark.path = entry_path
            newbookmark.haveconfig = haveconfig
            
            try:
                #self.bookmarks.append((entry_icon, entry_name, entry_path, haveconfig))
                self.bookmarks.append(newbookmark)
            except:
                #self.bookmarks = [(entry_icon, entry_name, entry_path, haveconfig)]
                self.bookmarks = [(newbookmark)]
            self.storetofile(self.bookmarks, "bookmarks")
            self.refresh_bookmarks()
            #print self.bookmarks
            widget.destroy ()
            return entryname                  
                
        elif response == gtk.RESPONSE_CANCEL:
            widget.destroy ()   
            return None               
        return None                
                
    def edit_bookmark_response(self, widget, response, *entry):
        #print 'widget: ' + str(widget)
        #print 'response: ' + str(response)
        entryname = self.dialog_bookmarks.get_widget("entry_bookmark_name")
        entrypath = self.dialog_bookmarks.get_widget("entry_bookmark_path")
        filechooserbutton_machine_icon = self.dialog_bookmarks.get_widget("filechooserbutton_machine_icon")
        
        entry_icon = str(filechooserbutton_machine_icon.get_filename())
        entry_icon_pixbuf = gtk.gdk.pixbuf_new_from_file(entry_icon)
        
        entry_name = str(entryname.get_text())
        entry_path = str(entrypath.get_text())
        haveconfig = str(self.check_haveconfig(entry_path))
        if haveconfig == True:
            config_icon = gtk.gdk.pixbuf_new_from_file('pixmaps/gtk-yes.png')
        else:
            config_icon = gtk.gdk.pixbuf_new_from_file('pixmaps/gtk-no.png')
        #print 'entryname: ' + entry_name
        #print 'entrypath: ' + entry_path
        if response == gtk.RESPONSE_OK:
            
            model, iter = self.treeview_bookmarks.get_selection().get_selected()
            counter = int(model.get_string_from_iter(iter))
            #print "counter: " + str(counter)
            #self.bookmark_tmpitem = self.bookmarks[counter]
                            
            editbookmark = Bookmark()
            editbookmark.icon = entry_icon
            editbookmark.name = entry_name
            editbookmark.path = entry_path
            editbookmark.haveconfig = haveconfig
            self.bookmarks[counter] = editbookmark
            #try:
                #self.bookmarks.append((entry_icon, entry_name, entry_path, haveconfig))
           #     self.bookmarks.append(newbookmark)
            #except:
                
                #self.bookmarks = [(entry_icon, entry_name, entry_path, haveconfig)]
                #self.bookmarks = [(newbookmark)]                
        #self.network_editredir = copy(self.tmpredir)
        #self.bookmark_tmpitem = self.bookmarks[counter]                          
            #model = self.treeview_bookmarks.get_model()
            
            
            #model.append(row=(entry_icon_pixbuf.scale_simple(24,24,3), entry_name, entry_path, config_icon))
            self.storetofile(self.bookmarks, "bookmarks")
            self.refresh_bookmarks()
            #print self.bookmarks
            widget.destroy ()
            return entryname      
        elif response == gtk.RESPONSE_CANCEL:
            widget.destroy ()   
            return None               
        return None
        
    def remove_bookmark(self, widget):
        entry_path = self.selected_bookmark
        #print 'widget: ' + str(widget)
        #print 'entry: ' + str(entry_path)
        model, iter = self.treeview_bookmarks.get_selection().get_selected()
        counter = int(model.get_string_from_iter(iter))
        #print "bookmark to remove: " + str(self.bookmarks[counter].name)
        print "bookmark ct to remove: " + str(counter)
        del self.bookmarks[counter]
        self.storetofile(self.bookmarks, "bookmarks")
        self.refresh_bookmarks()
        
        #sel = self.treeview_bookmarks.get_selection().get_selected()
        #print "iter: " + str(sel[1])
        #model = self.treeview_bookmarks.get_model()
        #icon = model.get_value(sel[1], 0)
        #name = model.get_value(sel[1], 1) 
        #path = model.get_value(sel[1], 2)
        #configicon = model.get_value(sel[1], 3)       
        #sysicon = str(icon.get_icon_name())
        
        #active = self.treeview_bookmarks.get_active()
        #model = self.treeview_bookmarks.get_model()
        #row = model[active]
        #icon = row[0]
        #name = row[1]
        #path = row[2]
        #configicon = row[3]
        #print "configicon: " + str(configicon) 
        #entryindex = self.search_bookmark(self.treeview_bookmarks, str(path), "index")
        #entry_name = self.search_bookmark(self.treeview_bookmarks, str(path), "name")
        #print "entryindex: " + str(entryindex)
        #time.sleep(0.3)
        #if entryindex != "None":
         #   sysicon = self.bookmarks[int(entryindex)].icon
          #  #sysicon = str(icon.get_icon_name())
           # haveconfig = self.check_haveconfig(path)
            #removelist = [(sysicon, name, path, haveconfig)]
            #print 'haveconfig: ' + str(haveconfig)
#            print 'removelist: ' + str(removelist)
 #           
  #          if haveconfig == True:
   #             config_icon = gtk.gdk.pixbuf_new_from_file('pixmaps/gtk-yes.png')
    #        else:
     #           config_icon = gtk.gdk.pixbuf_new_from_file('pixmaps/gtk-no.png')        
      #      
       #     if entryindex != "None":
        #        model = self.treeview_bookmarks.get_model()
         #       selectIter = model.get_iter(entryindex)
          #      #print str(selectIter)
           #     #print "entryindex" + str(entryindex)
                
            #    self.bookmarks.remove((sysicon, name, path, haveconfig))
                
             #   model.remove(selectIter)
              #  self.button_remove_bookmark.set_sensitive(False)
               # self.entry_current_image.set_text("")
#            else:
 #               print "no enty " + str(entry_path)  + " found"
  #  
   #         self.storetofile(self.bookmarks, "bookmarks")
    #        #print self.bookmarks
     #       return str(entry_name)

    def search_bookmark(self, widget, searchstring, returnval):
        ct = 0
        outct = "None"
        bmmodel = widget.get_model()
        
        print "searchstring: " + str(searchstring)
        #print "bmmodel: " + str(bmmodel)
        for row in bmmodel:
            #print "row: " + str(row[0]) + " - " + str(row[1]) + " - " + str(row[2])
            if searchstring == row[2]:
                print "row: " + str(row[0]) + " - " + str(row[1]) + " - " + str(row[2])
                #print "brow: " + row[0]
                #print "bct: " + str(ct)
                if returnval == "index":
                    outct = ct
                else:
                    outct = row[1]
                
            ct = ct + 1      
        print "search bookmark result: " + str(outct)            
        return outct            
     
        
    def select_image_from_path(self, widget):
        current = widget.get_text()
        #if current != "":
        if os.path.exists(current):
            print "entered path: " + str(current)
            isbookmark = False
            for bookmark in self.bookmarks:
                try:
                    if current == bookmark[1]:
                        #print "Bookmark: " + str(bookmark[1])
                        isbookmark = True
                except:
                    if current == bookmark.path:
                        #print "Bookmark: " + str(bookmark[1])
                        isbookmark = True                    

            self.button_remove_bookmark.set_sensitive(isbookmark)
            #return isbookmark        
            self.notebook_imgsettings.set_sensitive(True)
            self.currentimage = current
            #self.set_currentimage(current)
            self.fetch_currimage_config()
            self.button_add_bookmark.set_sensitive(True)
        else:
            self.label_imgsettings.set_markup(_('<b>No image selected</b>'))
            self.activate_launchbuttons( False )
            self.button_apply_imagesettings.set_sensitive(False)
            self.button_restore_imagesettings.set_sensitive(False)
            self.notebook_imgsettings.set_sensitive(False)  
            self.button_add_bookmark.set_sensitive(False)   
            
     
            
               
               
    def pop_up_bookmarks(self, widget, event):
        #print "widget: " + str(widget)
        #print "event: " + str(event)
        #print "data: " + str(data)        
        if event.button == 3:
            print "bookmark_popup"
            sel = self.treeview_bookmarks.get_selection().get_selected()
            #print "iter: " + str(sel[1])
            model = self.treeview_bookmarks.get_model()
            try:            
                self.selected_bookmark = model.get_value(sel[1], 2)            
    
                #menu_widgets = gtk.glade.XML(self.gladefile,"menu_popup_bookmarks")
                #self.menu_popup_bookmarks = menu_widgets.get_widget("menu_popup_bookmarks")
                print "sbookmark: " + str(self.selected_bookmark)
                self.menu_popup_bookmarks.popup(None, None, None, 3, 0)
            except:
                print "no bookmark selected"
        else:
            pass                     
            
    #def cdrive_selection(self, widget, path, *view_column):
    def cdrive_selection(self, widget):
        #print "widget: " + str(widget)
        #print "path: " + str(path)
        #print "view_column: " + str(view_column)
        model, iter = widget.get_selection().get_selected()
        row = model[iter]
        item = row[1]
        #print "item: %s" %item
        self.set_currentimage(item)  
        
        
        #model = widget.get_model()
        #row = model[path]
        #item = row[1]
        #print "item: %s" %item
        #self.set_currentimage(item)               
                   
    def pop_up_imagelist(self, widget, event):
        #print "widget: " + str(widget)
        #print "event: " + str(event)
        #print "data: " + str(data)
        
        if event.button == 3:
            sel = self.isolist.get_selection().get_selected()
            #print "iter: " + str(sel[1])
            model = self.isolist.get_model()
            try:
                self.selected_image = model.get_value(sel[1], 0)
                self.currentimage = self.selected_image
                print str(self.selected_image)
                self.menu_popup_imagelist.popup(None, None, None, 3, 0)
            except:
                print "no image selected"                   
            
    def pop_up_joblist(self, widget, event):
        

        sel = self.treeview_joblist.get_selection().get_selected()

        #print "iter: " + str(sel[1])
        model = self.treeview_joblist.get_model()
       # try:
        try:
            selected_job_path = model.get_value(sel[1], 0)
            selected_job_pty = model.get_value(sel[1], 1)
            selected_job_runstat = model.get_value(sel[1], 2)              
  

            #self.item_cont_job.set_sensitive(False)
            self.selected_job = [selected_job_path, selected_job_pty, selected_job_runstat]

            #print "job: " + str(self.selected_job)
            self.currentpts = self.selected_job[1]
         
            if selected_job_runstat == "1":
                self.item_cont_job.set_sensitive(False)    
                self.item_stop_job.set_sensitive(True) 
            else:
                self.item_cont_job.set_sensitive(True)    
                self.item_stop_job.set_sensitive(False)    
            time.sleep(0.01)
        
            if event.type == gtk.gdk._2BUTTON_PRESS:
                self.init_jobmanager()
            elif event.button == 3:
                self.menu_popup_joblist.popup(None, None, None, 3, 0)            
        except:
            print "no job selected"                    
            
            
        #except:   
           # print "no entry selected"
                
    def stop_job(self, widget, job=0):
            if job == 0:
                job = self.selected_job    
            pts = job[1]
            ptsin = PtsWrite(pts, "quit").start()  
            try:
                self.dialog_jobmonitor.get_widget("dialog_jobmonitor").destroy ()
            except:
                pass
            #self.jobman_get_usbhost(self)
            #time.sleep(1)
            
    def reset_job(self, widget, job=0):
        if job == 0:
            job = self.selected_job    
        pts = job[1]
        c = 0
        print "waiting for another qemu command..."
        while self.block_jobmon_update == True and c < 200:
            print "- " + str(c)
            time.sleep(0.3)      
            c = c+1
        ptsin = PtsWrite(pts, "system_reset").start() 
        jc = 0
        for jobs in self.joblist_data:
            if jobs != 0:
                if jobs[1] == pts:
                    self.joblist_data[jc] = [jobs[0], jobs[1], "0"]
                    #print "jobstop: " + str(self.joblist_data[jc][2])
            jc = jc+1
        self.item_cont_job.set_sensitive(True)    
        self.item_stop_job.set_sensitive(False) 
        self.refresh_joblist()
        print "reset done"            
            
    def pause_job(self, widget, job=0):
        if job == 0:
            job = self.selected_job    
        pts = job[1]
        c = 0
        print "waiting for another qemu command..."
        while self.block_jobmon_update == True and c < 200:
            print "- " + str(c)
            time.sleep(0.3)      
            c = c+1        
        ptsin = PtsWrite(pts, "stop").start() 
        jc = 0
        for jobs in self.joblist_data:
            if jobs != 0:
                if jobs[1] == pts:
                    self.joblist_data[jc] = [jobs[0], jobs[1], "0"]
                    #print "jobstop: " + str(self.joblist_data[jc][2])
            jc = jc+1
        self.item_cont_job.set_sensitive(True)    
        self.item_stop_job.set_sensitive(False) 
        self.refresh_joblist()
        print "job paused"
        
    def cont_job(self, widget, job=0):
        if job == 0:
            job = self.selected_job
        pts = job[1]
        c = 0
        print "waiting for another qemu command..."
        while self.block_jobmon_update == True and c < 200:
            print "- " + str(c)
            time.sleep(0.3)      
            c = c+1      
        ptsin = PtsWrite(pts, "cont").start()     
        jc = 0
        for jobs in self.joblist_data:
            if jobs != 0:
                if jobs[1] == pts:
                    #jobs[2] = 0
                    #self.joblist_data[jc][2] = "0"
                    self.joblist_data[jc] = [jobs[0], jobs[1], "1"]
                    #print "startstop: " + str(self.joblist_data[jc][2])
            jc = jc+1        
        self.item_cont_job.set_sensitive(False)    
        self.item_stop_job.set_sensitive(True)  
        self.refresh_joblist()        
        print "job continued"    
        #ptsin.start() 
        #ptsin = PtsWrite(self.currentpts, "info usbhost")
        
    def jobman_get_volumes(self, widget="", job=0):
            if job == 0:
                job = self.selected_job    
            pts = job[1]
            self.jobmessage = [] 
            ptsin = PtsWrite2(pts, "info block")
            ptsin.start()
            c = 0
            print "waiting for command return..."
            while ptsin.isAlive() and c < 50:
                print "- " + str(c)
                c = c+1
                time.sleep(0.3)
            
            devlist = self.jobmessage            
            
            lc = 0
            self.jobman_volumes_list = []
            for line in devlist:
                #self.jobman_volumes_list.append([line[0],line[1],devadr.group()])
                devdata = line.split(": ", 1)
                self.jobman_volumes_list.append(devdata)                
                lc = lc+1      


    def jobman_get_usbhost(self, widget="", job=0):
            if job == 0:
                job = self.selected_job    
            pts = job[1]
            self.jobmessage = []
            ptsin = PtsWrite2(pts, "info usbhost")
            ptsin.start()
            c = 0
            print "waiting for command return..."
            while ptsin.isAlive() and c < 50:
                print "- " + str(c)
                c = c+1
                time.sleep(0.3)
            
            devlist = self.jobmessage

            lc = 0
            self.usbhost_list = []
            for line in devlist:
                if lc%2 == 0:
                    #print line
                    line1 = line
                else:
                    devadr = re.search("[0-9a-f]{4}\:[0-9a-f]{4}", line)
                    if devadr != None:
                        self.usbhost_list.append([line1,line,devadr.group()])
                lc = lc+1                    
           # for devs in usbhost_list:
            #    print devs[0] + " - " + devs[1] + " - " + devs[2]
            
    def jobman_get_usbguest(self, widget="", job=0):
            if job == 0:
                job = self.selected_job    
            pts = job[1]
            self.jobmessage = []
            #PtsRead(pts).start()
            
            ptsout = open(pts, 'r')
            PtsRead(pts, ptsout).start()                      
            ptsin = PtsWrite(pts, "info usb").start()  
            #time.sleep(1)
            #devlist = self.jobmessage
            lc = 0
            #self.usbguest_list = []
            #self.jobmessage = []
            devlist = self.jobmessage
            #print "devlist usbguest " + str(devlist)
            c = 0
            print "waiting for devlist usbguest..."
            while devlist == [] and c != 10:
                print "- " + str(c)
                #PtsRead(pts).start()
                PtsRead(pts, ptsout).start()
                ptsin = PtsWrite(pts, "info usb").start()  
                time.sleep(0.3)    
                devlist = self.jobmessage
                c = c+1
                time.sleep(0.3)            
            #ptsout.close()
            for line in devlist:
                #devdata = f.split(",", 2)
               # if lc%2 == 0:
                 #   print line
                 #   line1 = line
                #else:
                    #devadr = re.search("[0-9a-f]{4}\:[0-9a-f]{4}", line)
                    #devadr = re.search("[0-9]+\.[0-9]+", selection).group()
                devdata = line.split(", ", 2)
                self.usbguest_list.append(devdata)
                lc = lc+1                  
        
    def show_infomessage(self, *widget):
        
        image = self.selected_image
        info = self.fetch_image_info(image)
        title = _('image info')
        self.init_messages_dialog(info, title)
        
    def show_infomessage_b(self, *widget):
        
        image = self.selected_bookmark
        info = self.fetch_image_info(image)
        title = _('image info')
        self.init_messages_dialog(info, title)      
        #print "message opened"
                                      
        
    def load_settings(self, *widget):
        print "load settings"
        self.settings = {}
        settings = {}
        
        settings["cdromdrives"] = [("CD-rom", "/dev/cdrom"),]
        settings["qemuapps"] = [("x86", "qemu"), 
        ("x86_64", "qemu-system-x86_64"),
        ("ppc", "qemu-system-ppc"),
        ("arm", "qemu-system-arm"), 
        ("mips", "qemu-system-mips"),
        ("mipsel", "qemu-system-mipsel"),
        ("sparc", "qemu-system-sparc"),]        
        self.qemubin = settings["qemuapps"][0][1]
        #try:
        outdata = self.getfromfile("mainsettings")
            
        if outdata  != {} and outdata != "":
            self.settings = outdata
            print "loaded settings from file"
            self.imagespath = self.settings["imagespath"]
        try:
            self.settings_autoshow = self.settings["settings_autoshow"]
            #self.toggle_settings_autoshow(self.settings_autoshow)
        except:
            pass
        try:        
            self.settings_autohide = self.settings["settings_autohide"]
            #self.toggle_settings_autohide(self.settings_autohide)
        except:
            pass
        try:            
            self.default_iconsize = self.settings["default_iconsize"]
        except:   
            pass         
        try:
            tstring = "cdromdrives: " + str(self.settings["cdromdrives"])
            del tstring
        except:
            self.settings["cdromdrives"] = settings["cdromdrives"]
            #print "cdromdrives1: " + str(self.settings["cdromdrives"])
        try:
            tstring = "qemuapps: " + str(self.settings["qemuapps"])
            del tstring
        except:                
            self.settings["qemuapps"] = settings["qemuapps"]
            #print "qemuapps1: " + str(self.settings["qemuapps"])
            
        self.toggle_settings_autoshow(self.settings_autoshow)
        self.toggle_settings_autohide(self.settings_autohide)
            
        #except:        
            #self.imagespath = "./images"
            #self.settings["cdromdrives"] = settings["cdromdrives"]
            #self.settings["qemuapps"] = settings["qemuapps"]
            #print "keine Datei, standard settings geladen"   
            
        self.get_soundhw()
            
    def get_soundhw(self, *event):
        #qemucommand = self.qemu_command()
        qemucommand = self.qemubin
        #print "get soundhw"  
        print "qemu system for soundcard detection: " + str(qemucommand)
        prog = os.popen(str(qemucommand) + " -soundhw ?")
        output = prog.readlines()
        output2 = []
        self.audio_devlist = []
        fc = 0
        for f in output:
            f = string.strip(f)
            if f != "":
                output2.append(f)
                fc = fc+1
        #print fc
        for f in output2:
            if f != output2[0] and f != output2[fc-1]:
                
                devdata = f.split(" ", 1)
                devdata = filter(None, devdata)
                devdata[0] = string.strip(devdata[0])
                devdata[1] = string.strip(devdata[1])
                self.audio_devlist.append(devdata)
        #print "available soundcard emulations:"
       # for dev in self.audio_devlist:
      #      print dev[1]  
    
    def refresh_soundhw(self, *event):
        audiomodel = self.combobox_audiohw.get_model()
        audiomodel.clear()
        audiomodel.append(row=("None",))
        for dev in self.audio_devlist:
            device = dev[0]
            name = dev[1]
            #print "dev: " + name + " - " + device
            audiomodel.append(row=(name,))
        self.combobox_audiohw.set_model(audiomodel)      
        self.combobox_audiohw.set_active(0)  
   
    def get_machine(self, *event):
        #print "get machine"  
        #print "qemu system: " + str(self.qemubin)
        prog = os.popen(str(self.qemubin) + " -M ?")
        output = prog.readlines()
        output2 = []
        self.machineslist = []
        fc = 0
        for f in output:
            #print "count machines: " + str(fc)
            f = string.strip(f)
            #print "f: " + str(f)
            if f != "":
                output2.append(f)
                fc = fc+1

        for f in output2:
            if f != output2[0]:
                devdata = f.split(" ", 1)
                devdata = filter(None, devdata)
                devdata[0] = string.strip(devdata[0])
                devdata[1] = string.strip(devdata[1])
                self.machineslist.append(devdata)
        #print "available machine emulations for this platform:"
        #for dev in self.machineslist:
            #print dev[1]     
            #print str(dev[0]) + " - " + str(dev[1])   
            
    def refresh_machineslist(self, *event):
        machinemodel = self.combobox_machinetype.get_model()
        machinemodel.clear()
        #machinemodel.append(row=("None",))
        print "available machine emulations for this platform:"
        for dev in self.machineslist:
            device = str(dev[0])
            name = str(dev[1])
            #print "dev: " + name + " - " + device
            print str(dev[0]) + " - " + str(dev[1])
            machinemodel.append(row=(name,))
            self.combobox_machinetype.set_model(machinemodel)  
        self.combobox_machinetype.set_active(0)     
                
    def refresh_ilist(self, *widget): 
        self.ilist_data = []   
        ilistmodel = self.isolist.get_model() 
        ilistmodel.clear()
        data=os.listdir(self.settings["imagespath"])
        data.sort()
        for entry in data:
            path = str(self.settings["imagespath"]) + "/" + str(entry)
            #print "path: " + path
            haveconfig = self.check_haveconfig(path)
            self.ilist_data.append((path, haveconfig))
        ilistmodel = self.create_model_ilist(self.ilist_data)    
        self.isolist.set_model(ilistmodel)
        
    def refresh_bookmarks(self, *widget): 
        self.load_bookmarks()
        #model = self.treeview_bookmarks.get_model() 
        #model.clear()
        #model.append(row=(name, path))
        #model = self.create_model_bookmarks(self.bookmarks)    
        #self.treeview_bookmarks.set_model(model)        
                
    def init_gui(self, *widget):
        
        self.switch_settingsview("show")
        #self.menu_toggle_settings_autohide(self.item_set_autohide)
        #self.menu_toggle_settings_autoshow(self.item_set_autoshow)
        self.toggle_settings_autohide(self.settings_autohide)
        self.toggle_settings_autoshow(self.settings_autoshow)
        
        
        try:
            data=os.listdir(self.settings["imagespath"])
            data.sort()
        except:
            data = [ _('Please go to settings and select a default images folder as the Home for your qemu-images')]
           
            #self.ilist_data[0] = "Please go to settings and select a default images folder as the Home for your qemu-images"
        #for entry in data:
        #    print "entry: " + str(entry)
        #    haveconfig = self.check_haveconfig(entry[0])
        #    self.ilist_data.append((str(entry[0]), haveconfig))
        for entry in data:
            
            #path = str(self.settings["imagespath"]) + "/" + str(entry)
            path = str(self.imagespath) + "/" + str(entry)
            
            #print "path: " + path
            haveconfig = self.check_haveconfig(path)
            self.ilist_data.append((path, haveconfig))            
            
        ilistmodel = self.create_model_ilist(self.ilist_data) 
        #ilistmodel = self.isolist.get_model()
        #ilistmodel.clear()        
        #ilistmodel = self.create_model_ilist(self.ilist_data)        
        self.isolist.set_model(ilistmodel)
        self.add_columns(self.isolist)
        
        #cdromlist = self.dialog_settings.get_widget("treeview_cdromdrives")
        cdlistmodel = self.create_model_cdromdrives(self.settings["cdromdrives"])
        self.treeview_cdrives.set_model(cdlistmodel)
        self.add_columns_cdromdrives(self.treeview_cdrives, cdlistmodel)         
        
        cdmodel = self.combobox_cdromdrive.get_model()
        cdmodel.clear()

        cdmodel.append(row=(None,))
        for dev in self.settings["cdromdrives"]:
            name = dev[0]
            device = dev[1]
            #print "dev: " + name + " - " + device
            
            cdmodel.append(row=(name,))
            self.combobox_cdromdrive.set_model(cdmodel)
            
        self.hdmodel = self.combobox_hda.get_model()
        self.hdmodel.clear()                    
        #try:
        #self.hdmodel.append(row=("None",))
        self.hdmodel.append(row=("None",))   

        #self.hdmodel.append(row=("---- " + _('main image folder') + " ----",))
         
        for item in self.ilist_data:
            path = item[0]
            #imagepath = self.imagespath + "/" + item[0]           
            #self.hdmodel.append(row=(imagepath,)) 
            self.hdmodel.append(row=(path,))      
           
        #self.hdmodel.append(row=("---- " + _('bookmarks') + " ----",))
        #for dev in self.bookmarks:
        #    try:
        #        name = dev[0]
        #        device = dev[1]
        #    except:
        #        name = dev.name
         #       device = dev.path             
            #print "dev: " + name + " - " + device
        #    self.hdmodel.append(row=(device,))                   
        
            
        self.cdimodel = self.combobox_imagecdrom.get_model()
        self.cdimodel.clear()                    
        #try:
        self.cdimodel.append(row=("None",))
          
        #self.cdimodel.append(row=("---- " + _('physical drives') + " ----",))
        #for dev in self.settings["cdromdrives"]:
        #    name = dev[0]
        #    device = dev[1]
            #print "dev: " + name + " - " + device
        #    self.cdimodel.append(row=(name,))     
            
        #self.cdimodel.append(row=("---- " + _('main image folder') + " ----",))
        for item in self.ilist_data:
            path = str(item[0])
            #imagepath = self.imagespath + "/" + item[0]
            #imagepath = path
            self.cdimodel.append(row=(path,))
            
         
            
          
            
        self.combobox_imagecdrom.set_model(self.cdimodel)   
        self.combobox_hda.set_model(self.hdmodel) 
        self.combobox_hdb.set_model(self.hdmodel) 
        self.combobox_hdc.set_model(self.hdmodel) 
        self.combobox_hdd.set_model(self.hdmodel) 
        self.combobox_fda.set_model(self.cdimodel) 
        self.combobox_fdb.set_model(self.cdimodel) 
            
        #audiomodel = self.combobox_audiohw.get_model()
        #audiomodel.clear()

        #audiomodel.append(row=("None",))
        #for dev in self.audio_devlist:
         #   device = dev[0]
            #name = dev[1]
            #print "dev: " + name + " - " + device
            
            #cdmodel.append(name)
            #audiomodel.append(row=(name,))
            #self.combobox_audiohw.set_model(audiomodel) 
            
        #netmodel = self.create_model_networkcards([])
        #self.add_columns_networkcards(self.treeview_networkcards,netmodel) 
        #self.refresh_networkcards() 
        self.radiobutton_network_usermode.set_active(True)
        self.toggle_networkuse(self.radiobutton_network_usermode)
        netmodel = self.create_model_networkcards([])        
        self.treeview_networkcards.set_model(netmodel)
        self.add_columns_networkcards(self.treeview_networkcards,netmodel)  
        
        redirmodel = self.create_model_redirects([])    
        self.treeview_redirects.set_model(redirmodel) 
        self.add_columns_redirects(self.treeview_redirects,redirmodel)             
           
        self.get_soundhw()
        self.refresh_soundhw() 
        
        self.get_machine()
        self.refresh_machineslist()
        
        ## initializing the systems listbox
        sysmodel = self.combobox_emusystem.get_model()
        try:
            sysmodel.clear()
        except:
            #print "nothing to clear"
            pass

        #sysmodel.append(row=("None",))
        for commands in self.settings["qemuapps"]:
            name = commands[0]
            path = commands[1]
            #print "path: " + name + " - " + path
            
            sysmodel.append(row=(name,))
        self.combobox_emusystem.set_model(sysmodel)  
        self.combobox_emusystem.set_active(0);      
        #self.select_emusystem(self.combobox_emusystem)
        self.emusystem = self.settings["qemuapps"][0][0]
        print "loaded default emusystem: " + str(self.emusystem)
            
## Load global settings        
    def init_settings(self, widget):
        self.load_settings()         

        
        self.dialog_settings = gtk.glade.XML(self.gladefile, "dialog_settings", APP)
        filechooserbutton_imagesdir = self.dialog_settings.get_widget("filechooserbutton_imagesdir") 
        
        cdromlist = self.dialog_settings.get_widget("treeview_cdromdrives")
        model = self.create_model_cdromdrives(self.settings["cdromdrives"])
        cdromlist.set_model(model)
        self.add_columns_cdromdrives(cdromlist, model) 
        
        # print "qemuapps loaded: " + str(self.settings["qemuapps"])
        qemulist = self.dialog_settings.get_widget("treeview_qemupaths")        
        qmodel = self.create_model_qemupaths(self.settings["qemuapps"])
        qemulist.set_model(qmodel)
        self.add_columns_qemupaths(qemulist, qmodel)   
        
        checkbutton_autoshow_settings = self.dialog_settings.get_widget("checkbutton_autoshow_settings")
        checkbutton_autohide_settings = self.dialog_settings.get_widget("checkbutton_autohide_settings")
        spinbutton_iconsize = self.dialog_settings.get_widget("spinbutton_iconsize")
        
        #try:
        checkbutton_autoshow_settings.set_active(self.settings_autoshow)
        #except:
        #    pass
        #try:
        checkbutton_autohide_settings.set_active(self.settings_autohide)
        #except:
        #    pass   
        #try:
        spinbutton_iconsize.set_value(int(self.default_iconsize))
        #except:
        #    pass              
        
        dic = {"on_dialog_settings_response" : self.settings_response
            , "on_treeview_cdromdrives_row_activated" : self.settings_get_cdromdevice
            , "on_button_settings_add_cdevice_clicked" : self.settings_add_cdromdevice
            , "on_button_settings_rem_cdevice_clicked" : self.settings_remove_cdromdevice
            , "on_treeview_qemupaths_row_activated" : self.settings_get_qemupath
            , "on_button_settings_add_qemubin_clicked" : self.settings_add_qemupath
            , "on_button_settings_rem_qemubin_clicked" : self.settings_remove_qemupath            
        }
        self.dialog_settings.signal_autoconnect(dic)
    
        if self.imagespath != "":
            filechooserbutton_imagesdir.set_filename(self.imagespath)              
        else:
            filechooserbutton_imagesdir.set_filename("")      

        
    def settings_get_cdromdevice(self, widget, path, view_column):

        model = widget.get_model()
        row = model[path]
        item = row[0]
        #print "item: %s" %item
        self.settings_set_currentcdromdev(row)    
        
    def settings_set_currentcdromdev(self, device_list):
    
            nameinput = self.dialog_settings.get_widget("entry_settings_cdevicename")
            devinput = self.dialog_settings.get_widget("entry_settings_cdevicepath")
            
            nameinput.set_text(device_list[0])
            devinput.set_text(device_list[1])  

    def settings_add_cdromdevice(self, widget):
            print "new cdromdevice"
            name = self.dialog_settings.get_widget("entry_settings_cdevicename").get_text()
            dev = self.dialog_settings.get_widget("entry_settings_cdevicepath").get_text()
            cdromlist = self.dialog_settings.get_widget("treeview_cdromdrives")
            model = cdromlist.get_model()
            model.append(row=(name, dev))
            print "device: " + name + " : " + dev
            
            try:
                self.settings["cdromdrives"].append((name, dev))
                #self.bookmarks.append((name, entry_path))
            except:
                self.settings["cdromdrives"] = [(name, dev)]
        
    def settings_remove_cdromdevice(self, widget):
        cdromlist = self.dialog_settings.get_widget("treeview_cdromdrives")
        name = self.dialog_settings.get_widget("entry_settings_cdevicename").get_text()
        dev = self.dialog_settings.get_widget("entry_settings_cdevicepath").get_text()
        #print 'name: ' + str(name)
        #print 'dev: ' + str(dev)
        entryindex = self.settings_search_cdromdevice(cdromlist, str(dev), "index")
        #entry_name = self.settings_search_cdromdevice(self.treeview_bookmarks, str(entry_path), "name")
        entry_name = name
        
        if entryindex != "None":
            model = cdromlist.get_model()
            selectIter = model.get_iter(entryindex)
            #print str(selectIter)
            #print "entryindex" + str(entryindex)
            model.remove(selectIter)
            #self.bookmarks.remove((entry_name, entry_path))
            self.settings["cdromdrives"].remove((name, dev))
            #self.button_remove_bookmark.set_sensitive(False)
            self.dialog_settings.get_widget("entry_settings_cdevicename").set_text("")
            self.dialog_settings.get_widget("entry_settings_cdevicepath").set_text("")
        else:
            print "no enty " + str(name)  + " found"

        #self.storetofile(self.bookmarks, "bookmarks")
        #print self.bookmarks
        return str(entry_name)

    def settings_search_cdromdevice(self, widget, searchstring, returnval):
        ct = 0
        outct = "None"
        bmmodel = widget.get_model()
        #print "bmmodel: " + str(bmmodel)
        for row in bmmodel:

            if searchstring == row[1]:
                #print "brow: " + row[0]
                #print "bct: " + str(ct)
                if returnval == "index":
                    outct = ct
                else:
                    outct = row[0]
                
            ct = ct + 1      
        print "result for cdrom device search: " + str(outct)            
        return outct      
    
    def create_model_qemupaths(self, data):
        store = gtk.ListStore(gobject.TYPE_STRING,
                          gobject.TYPE_STRING)
        for item in data:
            iter = store.append()
            itempath = item[0]
            itemname = item[1]
            #print itempath
            #print itemname
            store.set(iter, 0, item[0], 1, item[1])
        return store        
        
    def add_columns_qemupaths(self, treeview, model):
    
        renderer = gtk.CellRendererToggle()
        column = gtk.TreeViewColumn('Name', gtk.CellRendererText(), text=0)
        column2 = gtk.TreeViewColumn('Path', gtk.CellRendererText(), text=1)
        treeview.append_column(column)   
        treeview.append_column(column2)           
    
    def settings_get_qemupath(self, widget, path, view_column):

        model = widget.get_model()
        row = model[path]
        item = row[0]
        #print "item: %s" %item
        self.settings_set_currentqemupath(row)    
        
    def settings_set_currentqemupath(self, device_list):
    
            nameinput = self.dialog_settings.get_widget("entry_settings_qemuname")
            devinput = self.dialog_settings.get_widget("entry_settings_qemupath")
            
            nameinput.set_text(device_list[0])
            devinput.set_text(device_list[1])  
    
    def settings_add_qemupath(self, widget):
            print "new qemupath"
            name = self.dialog_settings.get_widget("entry_settings_qemuname").get_text()
            path = self.dialog_settings.get_widget("entry_settings_qemupath").get_text()
            qemulist = self.dialog_settings.get_widget("treeview_qemupaths")
            model = qemulist.get_model()
            model.append(row=(name, path))
            print "qemuapp: " + name + " : " + path
            
            try:
                self.settings["qemuapps"].append((name, path))
                #self.bookmarks.append((name, entry_path))
            except:
                self.settings["qemuapps"] = [(name, path)]    
                
    def settings_remove_qemupath(self, widget):
        qemulist = self.dialog_settings.get_widget("treeview_qemupaths")
        name = self.dialog_settings.get_widget("entry_settings_qemuname").get_text()
        path = self.dialog_settings.get_widget("entry_settings_qemupath").get_text()
        #print 'name: ' + str(name)
        #print 'path: ' + str(path)
        entryindex = self.settings_search_cdromdevice(qemulist, str(path), "index")
        #entry_name = self.settings_search_cdromdevice(self.treeview_bookmarks, str(entry_path), "name")
        entry_name = name
        
        if entryindex != "None":
            model = qemulist.get_model()
            selectIter = model.get_iter(entryindex)
            #print str(selectIter)
            #print "entryindex" + str(entryindex)
            model.remove(selectIter)
            #self.bookmarks.remove((entry_name, entry_path))
            self.settings["qemuapps"].remove((name, path))
            #self.button_remove_bookmark.set_sensitive(False)
            self.dialog_settings.get_widget("entry_settings_qemuname").set_text("")
            self.dialog_settings.get_widget("entry_settings_qemupath").set_text("")
        else:
            print "no enty " + str(name)  + " found"

        #self.storetofile(self.bookmarks, "bookmarks")
        #print self.bookmarks
        return str(entry_name)                
        
    def settings_response(self, widget, response, *entry):
    
        if response == gtk.RESPONSE_OK or response == gtk.RESPONSE_APPLY:
            #print 'widget: ' + str(widget)
            #print 'response: ' + str(response)
            treeview_cdromdrives = self.dialog_settings.get_widget("treeview_cdromdrives")
            treeview_qemupaths = self.dialog_settings.get_widget("treeview_qemupaths")
            filechooserbutton_imagesdir = self.dialog_settings.get_widget("filechooserbutton_imagesdir")

            checkbutton_autoshow_settings = self.dialog_settings.get_widget("checkbutton_autoshow_settings")
            checkbutton_autohide_settings = self.dialog_settings.get_widget("checkbutton_autohide_settings")
            spinbutton_iconsize = self.dialog_settings.get_widget("spinbutton_iconsize")
            #self.settings_autoshow
            self.settings["settings_autoshow"] = checkbutton_autoshow_settings.get_active()
            self.settings["settings_autohide"] = checkbutton_autohide_settings.get_active()
            self.settings["default_iconsize"] = str(spinbutton_iconsize.get_value_as_int())
            defaultpath = filechooserbutton_imagesdir.get_filename()
            self.settings["imagespath"] = defaultpath
            print "default images path: " + defaultpath
            #entrypath = self.dialog_bookmarks.get_widget("entry_bookmark_path")
            #model = treeview_cdromdrives.get_model()
            #entry_path = str(entrypath.get_text())
            #print 'model: ' + str(model)
            
            #for i in model:
             #   row = i
              #  name = row[0]
              #  device = row[1]
              #  print "device: " + name + " : " + device
                #print "device: %s" %device
                
            self.storetofile(self.settings, "mainsettings")
            print "settings saved!"
            #self.refresh_ilist()
        
        #print 'entrypath: ' + entry_path
        if response == gtk.RESPONSE_OK:
            self.load_settings()
            self.refresh_ilist()
            self.refresh_bookmarks()
            widget.destroy ()
        if response == gtk.RESPONSE_APPLY:
            self.load_settings()
            self.refresh_ilist()
            self.refresh_bookmarks()           
        if response == gtk.RESPONSE_CANCEL:
            print "aborted!"        
            widget.destroy ()    
        #self.load_settings()  
        
    def init_about(self, widget):
        self.dialog_about = gtk.glade.XML(self.gladefile, "dialog_about", APP)
        dic = {"on_dialog_about_response" : self.dialog_about_response,
        }
        self.dialog_about.signal_autoconnect(dic)        
        
    def dialog_about_response(self, widget, response, *entry):    
        if response == gtk.RESPONSE_CLOSE:
            widget.destroy ()
            pass    
            
    def init_create_image(self, widget):
        
        self.dialog_create_image = gtk.glade.XML(self.gladefile, "dialog_create_image", APP)
        ## widgets of the new image dialog
        
        self.filechooserbutton_newimage_dest = self.dialog_create_image.get_widget("filechooserbutton_newimage_dest")
        self.entry_newimage_name = self.dialog_create_image.get_widget("entry_newimage_name")
        self.combobox_newimage_format = self.dialog_create_image.get_widget("combobox_newimage_format")
        self.spinbutton_newimage_size = self.dialog_create_image.get_widget("spinbutton_newimage_size")
        self.combobox_newimage_sizeunit = self.dialog_create_image.get_widget("combobox_newimage_sizeunit")
        self.button_create_image = self.dialog_create_image.get_widget("button_create_image")        
        
        self.newimagename = ""
        self.combobox_newimage_sizeunit.set_active(0)
        self.set_newimagesize()
        self.combobox_newimage_format.set_active(0)
        self.set_newimageformat()      
        self.filechooserbutton_newimage_dest.set_filename(self.imagespath)
        self.set_newimage_folder()
        dic = {"on_dialog_create_image_response" : self.dialog_create_image_response
        # handlers for the new image dialog
        , "on_filechooserbutton_newimage_dest_selection_changed" : self.set_newimage_folder
        , "on_entry_newimage_name_changed" : self.set_newimage_name
        , "on_combobox_newimage_format_changed" : self.set_newimageformat
        , "on_spinbutton_newimage_size_changed" : self.set_newimagesize
        , "on_combobox_newimage_sizeunit_changed" : self.set_newimagesize
        , "on_button_create_image_clicked" : self.create_newimage
        }
        self.dialog_create_image.signal_autoconnect(dic)  
        
    def set_newimage_folder(self, *widget):
        self.newimagepath = self.filechooserbutton_newimage_dest.get_filename()
        #print "path: " + self.newimagepath
        
    def set_newimage_name(self, *widget):
        self.newimagename = self.entry_newimage_name.get_text() 
        #print "name: " + self.newimagename    
        
    def set_newimageformat(self, *widget):
        #self.newimageformat = self.combobox_newimage_format.get_active()
        active = self.combobox_newimage_format.get_active()
        model = self.combobox_newimage_format.get_model()
        row = model[active]
        self.newimageformat = row[0]
        #if self.newimageformat == "Auto":
        #    self.newimageformat = ""
        #self.newimageformat = item
        #print "format: " + str(self.newimageformat)
        
    def set_newimagesize(self, *widget):
        sizevalue = self.spinbutton_newimage_size.get_value()
        #sizeunit = self.combobox_newimage_sizeunit.get_active()
        active = self.combobox_newimage_sizeunit.get_active()
        model = self.combobox_newimage_sizeunit.get_model()
        row = model[active]
        sizeunit = row[0]
        
        if sizeunit == "KB":
            self.newimage_size = str(int(sizevalue))
        elif sizeunit == "MB":
            self.newimage_size = str(int(sizevalue)) + "M"
        elif sizeunit == "GB":
            self.newimage_size = str(int(sizevalue)) + "G" 
        else:
            self.newimage_size = str(int(sizevalue))
        #print "size: " + self.newimage_size
        
    def create_newimage(self, widget):
        if self.newimagename != "":
            newimagetarget = self.newimagepath + "/" + self.newimagename
            if self.newimageformat != "Auto":
                formatcommand = "-f " + self.newimageformat
            else:
                formatcommand = ""
            command = "qemu-img create " + formatcommand + " " + newimagetarget + " " + self.newimage_size
            #print command
            runcreate = os.popen(command).read()
            message = command + "\n" + str(runcreate)
            
            #message = popen2.popen3(command)
            #message = commexec.

            print str(message)
            self.init_messages_dialog(str(message))
            self.messagesbuffer.set_text(str(message))
            self.refresh_ilist()
        else:
            message = _('No name given for the new image!\nplease enter a name and try again.')
            #" + _('No name given for the new image!\nplease enter a name and try again.') + "
            self.init_messages_dialog(message)
            
    def dialog_create_image_response(self, widget, response, *entry):    
        if response == gtk.RESPONSE_CLOSE:
            widget.destroy ()
            pass 
            
    def init_messages_dialog(self, message, *title):
        self.dialog_messages = gtk.glade.XML(self.gladefile, "dialog_messages", APP)
        #if title:
        #    self.dialog_messages.set_title(title)
        self.textview_messages = self.dialog_messages.get_widget("textview_messages")
        self.messagesbuffer = self.textview_messages.get_buffer()
        self.messagesbuffer.set_text(message)
        
        dic = {"on_dialog_messages_response" : self.dialog_messages_response,        
        }
        self.dialog_messages.signal_autoconnect(dic)         
        
    def dialog_messages_response(self, widget, response, *entry):    
        if response == gtk.RESPONSE_CLOSE:
            widget.destroy ()
            pass   
        
    #def select_networkcard(self, widget, path, view_column):
    def select_networkcard(self, widget):
        sel = self.treeview_redirects.get_selection()
        sel.unselect_all()
        #self.treeview_redirects.set_state(gtk.STATE_NORMAL)
    
    #def select_networkredir(self, widget, path, view_column):
    def select_networkredir(self, widget):
        sel = self.treeview_networkcards.get_selection()
        sel.unselect_all()
        #self.treeview_networkcards.set_state(gtk.STATE_NORMAL)   
            
      
    def init_networksetup(self, widget):
        GoOn = True        
        button = widget.get_name()
        if button == "button_network_netcard_add":
            mode = "add"
            response = self.dialog_add_netcard_response
        if button == "button_network_edit":
            mode = "edit"
            response = self.dialog_edit_netcard_response       
        print "network card setup opened for: " + str(mode)


        if mode == "edit":
            try:
                model, iter = self.treeview_networkcards.get_selection().get_selected()
                counter = int(model.get_string_from_iter(iter))
                GoOn = True
            except:
                print "No network card selected"
                GoOn = False
                try:
                    model, iter = self.treeview_redirects.get_selection().get_selected()
                    counter = int(model.get_string_from_iter(iter))
                    self.init_network_redirect(widget)
                    GoOn = False
                except:
                    print "No redirect selected"
                    GoOn = False                
                
            
                
        if GoOn == True:

            self.tmpnetwork = Network()
            
            self.dialog_newnetcard = gtk.glade.XML(self.gladefile, "dialog_newnetcard", APP)
            self.dialog_newnetcard_widget = self.dialog_newnetcard.get_widget("dialog_newnetcard")
            ## widgets of the new image dialog
            
            self.combobox_networktype = self.dialog_newnetcard.get_widget("combobox_networktype")
            self.combobox_networktype.set_active(0)
            self.select_networktype(self.combobox_networktype)
            
            self.entry_network_ip = self.dialog_newnetcard.get_widget("entry_network_ip")
            self.spinbutton_network_port = self.dialog_newnetcard.get_widget("spinbutton_network_port")
            self.entry_network_macaddr = self.dialog_newnetcard.get_widget("entry_network_macaddr")
            self.spinbutton_network_vlan = self.dialog_newnetcard.get_widget("spinbutton_network_vlan")
            self.entry_network_tuntapscript = self.dialog_newnetcard.get_widget("entry_network_tuntapscript")        
            self.button__network_open_tuntap_file = self.dialog_newnetcard.get_widget("button__network_open_tuntap_file")
            self.entry_network_ifacename = self.dialog_newnetcard.get_widget("entry_network_ifacename")
            self.spinbutton_network_filedescriptor = self.dialog_newnetcard.get_widget("spinbutton_network_filedescriptor")
            
            dic = {"on_combobox_networktype_changed" : self.select_networktype
            , "on_entry_network_ip_changed" : self.set_network_ip
            , "on_spinbutton_network_port_changed" : self.set_network_port
            , "on_entry_network_macaddr_changed" : self.set_network_mac
            , "on_spinbutton_network_vlan_changed" : self.set_network_vlan
            , "on_entry_network_tuntapscript_changed" : self.set_network_ttscript
            , "on_entry_network_ifacename_changed" : self.set_network_ifname
            , "on_spinbutton_network_filedescriptor_changed" : self.set_network_ttfiledesc
            , "on_dialog_newnetcard_response" : response
            }
            self.dialog_newnetcard.signal_autoconnect(dic)  
            
            
            if mode == "edit":
                self.dialog_newnetcard_widget.set_title("Edit selected network card")
                #model, iter = self.treeview_networkcards.get_selection().get_selected()
                #counter = int(model.get_string_from_iter(iter))
                self.network_editcard = self.networksetup[counter]
                self.tmpnetwork = self.network_editcard
                
                searchentry = self.search_combolist(self.combobox_networktype, self.network_editcard.ntype)
                #print "actct2 " + str(actct2)
                if searchentry != "":
                    self.combobox_networktype.set_active(searchentry)
                
                self.entry_network_ip.set_text(str(self.network_editcard.ip))
                self.spinbutton_network_port.set_value(int(self.network_editcard.port))
                self.entry_network_macaddr.set_text(str(self.network_editcard.mac))
                self.spinbutton_network_vlan.set_value(int(self.network_editcard.vlan))
                self.entry_network_tuntapscript.set_text(str(self.network_editcard.ttscript))
                self.entry_network_ifacename.set_text(str(self.network_editcard.ifname))
                self.spinbutton_network_filedescriptor.set_text(str(self.network_editcard.ttfiledesc))
        
    def dialog_add_netcard_response(self, widget, response, *entry):    
        if response == gtk.RESPONSE_CANCEL:
            self.tmpnetwork = []
            widget.destroy ()
            #pass   
        if response == gtk.RESPONSE_OK:
            self.networksetup.append(self.tmpnetwork)
            #for card in self.networksetup:
            #command = self.tmpnetwork.create_qemucommand()
            #print "command: " + str(command)
            self.tmpnetwork = []
            self.refresh_networkcards()
            print "Network device stored"
            widget.destroy ()
            self.button_apply_imagesettings.set_sensitive(True)
            self.button_restore_imagesettings.set_sensitive(True)
            
    def dialog_edit_netcard_response(self, widget, response, *entry):    
        if response == gtk.RESPONSE_CANCEL:
            self.tmpnetwork = []
            widget.destroy ()
            #pass   
        if response == gtk.RESPONSE_OK:
            #self.networksetup.append(self.tmpnetwork)
            self.network_editcard = self.tmpnetwork
            #command = self.tmpnetwork.create_qemucommand()
            #print "command: " + str(command)
            self.tmpnetwork = []
            self.refresh_networkcards()
            print "Network device changed"
            widget.destroy ()
            self.button_apply_imagesettings.set_sensitive(True)
            self.button_restore_imagesettings.set_sensitive(True)            
            
    def remove_netcard(self, widget):
        #sel = self.treeview_networkcards.get_selection().get_selected()
        GoOn = True
        try:
            model, iter = self.treeview_networkcards.get_selection().get_selected()
            counter = int(model.get_string_from_iter(iter))
        except:
            print "No network card selected for remove"
            GoOn = False
            try:
                model, iter = self.treeview_redirects.get_selection().get_selected()
                counter = int(model.get_string_from_iter(iter))
                self.remove_redirect(widget)
                GoOn = False
            except:
                print "No redirect selected for remove"
                GoOn = False           
        if GoOn == True:
            ip = model.get_value(iter, 0)
            port = model.get_value(iter, 1)
            vlan = model.get_value(iter, 2)
            #print str(iter)
            counter = int(model.get_string_from_iter(iter))
            #print "selected counter:" + str(counter)
            del self.networksetup[counter]
            #print "selected netcard:" + str(ip) + " - " + str(vlan)
            #print str(model)
            #self.tmpnetwork = []
            self.refresh_networkcards() 
            self.button_apply_imagesettings.set_sensitive(True)
            self.button_restore_imagesettings.set_sensitive(True) 

                     
        
    def select_networktype(self, widget):
        active = widget.get_active()
        model = widget.get_model()
        row = model[active]
        item = row[0]
        print "networktype: " + item
        self.tmpnetwork.ntype = item
        #print "Set tmpnetwork ntype to: " + str(self.tmpnetwork.ntype)
        
    def set_network_ip(self, widget):
        ip = widget.get_text()
        self.tmpnetwork.ip = ip
        #print "Set tmpnetwork ip to: " + str(self.tmpnetwork.ip)
        
    def set_network_port(self, *widget):
        port = int(self.spinbutton_network_port.get_value())
        #print "changed port to: " + str(port)
        self.tmpnetwork.port = port       
        
    def set_network_mac(self, widget):
        mac = widget.get_text()
        self.tmpnetwork.mac = mac
        #print "Set tmpnetwork macaddr to: " + str(self.tmpnetwork.mac)   
        
    def set_network_vlan(self, *widget):
        vlan = int(self.spinbutton_network_vlan.get_value())
        #print "changed vlan to: " + str(vlan)
        self.tmpnetwork.vlan = vlan  
        
    def set_network_ttscript(self, widget):
        ttscript = widget.get_text()
        self.tmpnetwork.ttscript = ttscript
        #print "Set tmpnetwork tun/tap script to: " + str(self.tmpnetwork.ttscript)     
        
    def set_network_ifname(self, widget):
        ifname = widget.get_text()
        self.tmpnetwork.ifname = ifname
        #print "Set tmpnetwork interface name to: " + str(self.tmpnetwork.ifname)  
        
    def set_network_ttfiledesc(self, widget):
        ttfiledesc = int(self.spinbutton_network_filedescriptor.get_value())
        #print "changed vlan to: " + str(ttfiledesc)
        self.tmpnetwork.ttfiledesc = ttfiledesc 
        
    def set_usernet_hostname(self, widget):
            network_hostname = widget.get_text()
            #self.network_hostname = network_hostname
            self.usernetwork.hostname = network_hostname
            #print "network_hostname: " + str(self.usernetwork.hostname)  
            self.button_apply_imagesettings.set_sensitive(True)
            self.button_restore_imagesettings.set_sensitive(True)    
            
    def set_usernet_vlan(self, widget):
            usernet_vlan = str(self.spinbutton_usernet_vlan.get_value_as_int())
            #self.network_hostname = network_hostname
            self.usernetwork.vlan = usernet_vlan
            #print "usernetwork.vlan: " + str(self.usernetwork.vlan)  
            self.button_apply_imagesettings.set_sensitive(True)
            self.button_restore_imagesettings.set_sensitive(True)                                                    

        
    def toggle_networkuse(self, widget): 
        wname = widget.get_name()    
        #wval = widget.get_value()
        #print "wname: " + wname    
        #print "wval: " + wval  
        if wname == "radiobutton_network_nonet" or wname == "radiobutton_network_usermode":
            #self.button_network_netcard_add.set_sensitive(False)
            self.button_network_netcard_add.hide()
            #self.button_network_redir_add.set_sensitive(False)
            self.button_network_redir_add.hide()
            #self.button_network_edit.set_sensitive(False)
            self.button_network_edit.hide()
            #self.button_network_remove.set_sensitive(False)
            self.button_network_remove.hide()
            self.treeview_networkcards.set_sensitive(False)
            #self.treeview_networkcards.hide()
            self.treeview_redirects.set_sensitive(False)
            #self.label_network_netcards.hide()
            self.label_network_netcards.set_sensitive(False)
            self.label__network_redirects.set_sensitive(False)
            self.filechooserbutton_network_smbshare.set_sensitive(True)
            #self.checkbutton_smbshare.set_sensitive(True)
            self.filechooserbutton_network_smbshare.show()
            self.checkbutton_smbshare.show()
        if wname == "radiobutton_network_nonet":
            self.networkmode = "nonet"
            #self.filechooserbutton_network_smbshare.set_sensitive(False)
            self.filechooserbutton_network_smbshare.hide()
            #self.checkbutton_smbshare.set_sensitive(False)
            self.checkbutton_smbshare.hide()
            self.entry_network_hostname.hide()
            self.hbox_usernet_vlan.hide()
            self.label_hostname.hide()
            #self.entry_network_hostname.set_sensitive(False)
            self.entry_network_hostname.hide()
            #self.hbox_usernet_vlan.set_sensitive(False)
            self.hbox_usernet_vlan.hide()
            self.networkoptions = "-net none"
            
        if wname == "radiobutton_network_customsetup":
            self.networkmode = "custom"
            #self.button_network_netcard_add.set_sensitive(True)
            self.button_network_netcard_add.show()
            #self.button_network_redir_add.set_sensitive(True)
            self.button_network_redir_add.show()
            #self.button_network_edit.set_sensitive(True)
            self.button_network_edit.show()
            #self.button_network_remove.set_sensitive(True)
            self.button_network_remove.show()
            self.treeview_networkcards.set_sensitive(True)
            self.treeview_redirects.set_sensitive(True)
            self.label_network_netcards.set_sensitive(True)
            self.label__network_redirects.set_sensitive(True)   
            self.filechooserbutton_network_smbshare.set_sensitive(True)   
            self.checkbutton_smbshare.set_sensitive(True)
            #self.entry_network_hostname.set_sensitive(False) 
            self.entry_network_hostname.hide()
            #self.hbox_usernet_vlan.set_sensitive(False)
            self.hbox_usernet_vlan.hide()
            self.label_hostname.hide()
            self.filechooserbutton_network_smbshare.show()
            self.checkbutton_smbshare.show()
        if wname == "radiobutton_network_usermode":  
            self.networkmode = "usermode"            
            #self.networkoptions = "-net nic,vlan=0 -net user,vlan=0,hostname=emu"
            #self.entry_network_hostname.set_sensitive(True)
            self.entry_network_hostname.show()
            #self.hbox_usernet_vlan.set_sensitive(True)
            self.hbox_usernet_vlan.show()
            self.label_hostname.show()
            self.filechooserbutton_network_smbshare.show()
            self.checkbutton_smbshare.show()
        
        #print "curr pos: " + str(self.vpaned_mainwindow.get_position())
        #self.vbox_bottompane.hide()
        #self.vpaned_mainwindow.remove(self.vbox_bottompane)
        #self.vpaned_mainwindow.pack2(self.vbox_bottompane, resize=True, shrink=True)
        #self.vpaned_mainwindow.queue_resize()
        self.vpaned_mainwindow.set_position(900)
        
        #print "new pos: " + str(self.vpaned_mainwindow.get_position())
        #self.vpaned_mainwindow.compute_position(800, 600, 200)
        #self.vpaned_mainwindow.queue_resize()
        self.button_apply_imagesettings.set_sensitive(True)
        self.button_restore_imagesettings.set_sensitive(True)
        
    def vpane_doubleclick(self, widget, event):
        
        if self.settingsvisible == "visible":
            if event.type == gtk.gdk._2BUTTON_PRESS:
                time.sleep(0.2)
                self.toggle_settingsview()
        else:
            if event.button == 1:
                time.sleep(0.2)
                self.toggle_settingsview()
            

        
    def toggle_settingsview(self, *widget):
        if self.settingsvisible == "visible":
            self.switch_settingsview("hide")
            
        else:
            self.switch_settingsview("show")
            
    def menu_toggle_settings_autohide(self, widget):
        #print "widget name: " + str(widget.get_name())
        #time.sleep(0.2)
        self.settings_autohide = widget.get_active()
        #print "menu autohide aktiv: " + str(self.settings_autohide)
        #if widget.get_active() == True:
            #self.settings_autohide = True
    def menu_toggle_settings_autoshow(self, widget):
        #print "widget name: " + str(widget.get_name())
        #time.sleep(0.2)
        self.settings_autoshow = widget.get_active()
        #print "menu autoshow aktiv: " + str(self.settings_autoshow)            
            
    def toggle_settings_autohide(self, status):
        #self.settings_autohide = status

        #self.item_set_autohide.set_active(self.settings_autohide)
        #self.item_set_autohide.set_inconsistent(True)
        #self.item_set_autohide.activate()
        #self.item_set_autohide.set_active(True)
        #self.item_set_autohide.hide()
        #self.item_set_autohide.toggled(self.item_set_autohide, True)
        #self.menu_toggle_settings_autohide(self.item_set_autohide)
        self.checkbutton_autohide_settings.set_active(status)
        #self.item_set_autohide.toggle()
        #self.item_set_autohide.set_active(False)
        print "autohide aktiv: " + str(self.settings_autohide)
        
        #autohidestat = self.item_set_autohide.get_active()
        #print "menu autohidestat: " + str(autohidestat)        
        #if widget.get_active() == True:
            #self.settings_autohide = True
    def toggle_settings_autoshow(self, status):
        #self.settings_autoshow = status

        #self.item_set_autoshow.set_active(self.settings_autoshow)
        #self.item_set_autoshow.set_inconsistent(True)
        #self.item_set_autoshow.set_active(status)
        #self.menu_toggle_settings_autoshow(self.item_set_autoshow)
        #self.item_set_autoshow.toggle()
        #self.item_set_autoshow.set_active(False)
        self.checkbutton_autoshow_settings.set_active(status)
        print "autoshow aktiv: " + str(self.settings_autoshow)  
        
        #autoshowstat = self.item_set_autoshow.get_active()
        #print "menu autoshowstat: " + str(autoshowstat)                   

    def switch_settingsview(self, showhide):
        #self.vbox_bottompane.hide()
        button_icon = gtk.Image()
        
        if showhide == "show":
            self.vpaned_mainwindow.remove(self.vbox_bottompane)
            self.vpaned_mainwindow.pack2(self.vbox_bottompane, resize=True, shrink=False)
            self.vpaned_mainwindow.set_position(1200)
            settingstxt = "hide settings"
            settingstt = "hide configuration panel for selected boot image"
            button_icon.set_from_icon_name("gtk-go-down", gtk.ICON_SIZE_BUTTON)
            self.settingsvisible = "visible"
        if showhide == "hide":
            self.vpaned_mainwindow.remove(self.vbox_bottompane)
            self.vpaned_mainwindow.pack2(self.vbox_bottompane, resize=True, shrink=True)
            self.vpaned_mainwindow.set_position(1200)   
            settingstxt = "show settings"  
            settingstt = "show configuration panel for selected boot image"
            button_icon.set_from_icon_name("gtk-go-up", gtk.ICON_SIZE_BUTTON)
            self.settingsvisible = "hidden"   
            
        #image = gtk.Image()
        
        
        self.button_togglesettings.set_image(button_icon)
        
        self.button_togglesettings.set_label(settingstxt)
        tooltips.set_tip(self.button_togglesettings, settingstt)
        
    def refresh_networkcards(self, *event):
        #model = self.create_model_networkcards([])
        model = self.treeview_networkcards.get_model()
        #self.add_columns_networkcards(self.treeview_networkcards,model)
        model.clear()
        #model.append(row=("None",))
        #try:
        currnet = self.networksetup
        if currnet != []:
            for netcard in currnet:
                ip = netcard.ip
                port = netcard.port
                vlan = netcard.vlan
                ntype = netcard.ntype
                model.append(row=(ip,port,vlan,ntype))
                print "Network card: " + str(ip) + " " + str(vlan) + " " + str(ntype)
        #except:
        #    print "no cards in: " + str(currnet)
        
        self.treeview_networkcards.set_model(model) 
        self.button_apply_imagesettings.set_sensitive(True)
        self.button_restore_imagesettings.set_sensitive(True)             
        #self.treeview_networkcards.set_active(0)             
                       
    def create_model_networkcards(self, data):
        store = gtk.ListStore(gobject.TYPE_STRING,
                          gobject.TYPE_STRING,
                          gobject.TYPE_STRING,
                          gobject.TYPE_STRING)
        for item in data:
            iter = store.append()
            ip = item[0]
            port = item[1]
            vlan = item[2]
            ntype = item[3]
            #print itempath
            #print itemname
            store.set(iter, 0, item[0], 1, item[1], 2, item[2], 3, item[3])
        return store    

    def add_columns_networkcards(self, treeview, model):
    
        renderer = gtk.CellRendererToggle()
        column0 = gtk.TreeViewColumn(_('IP'), gtk.CellRendererText(), text=0)
        column1 = gtk.TreeViewColumn(_('Port'), gtk.CellRendererText(), text=1)
        column2 = gtk.TreeViewColumn(_('VLAN'), gtk.CellRendererText(), text=2)
        column3 = gtk.TreeViewColumn(_('Network Type'), gtk.CellRendererText(), text=3)
        treeview.append_column(column0)   
        treeview.append_column(column1)        
        treeview.append_column(column2) 
        treeview.append_column(column3)  
        
## All functions for Network redirections ##

    def init_network_redirect(self, widget):
        GoOn = True  
              
        button = widget.get_name()
        if button == "button_network_redir_add":
            mode = "add"
            response = self.dialog_network_add_redirect_response
        if button == "button_network_edit":
            mode = "edit"
            response = self.dialog_network_edit_redirect_response       
        print "redirections setup opened for: " + str(mode)


        if mode == "edit":
            try:
                model, iter = self.treeview_redirects.get_selection().get_selected()
                counter = int(model.get_string_from_iter(iter))
            except:
                print "No redirect selected"
                GoOn = False
                
        if GoOn == True:

            self.tmpredir = Network_Redirection()
            self.tmpredir.protocol = "TCP"
            
            self.dialog_new_redirect = gtk.glade.XML(self.gladefile, "dialog_new_redirect", APP)
            self.dialog_new_redirect_widget = self.dialog_new_redirect.get_widget("dialog_new_redirect")
            ## widgets of the new image dialog
            
            
        
            
            self.radiobutton_redirect_TCP = self.dialog_new_redirect.get_widget("radiobutton_redirect_TCP")
            self.radiobutton_redirect_UDP = self.dialog_new_redirect.get_widget("radiobutton_redirect_UDP")
            self.spinbutton_redirect_sport = self.dialog_new_redirect.get_widget("spinbutton_redirect_sport")            
            self.entry_redirect_gIP = self.dialog_new_redirect.get_widget("entry_redirect_gIP")
            self.spinbutton_redirect_dport = self.dialog_new_redirect.get_widget("spinbutton_redirect_dport")        
            self.button_redirect_add = self.dialog_new_redirect.get_widget("button_redirect_add")
            dic = {"on_radiobutton_redirect_TCP_toggled" : self.set_redir_prot
            , "on_radiobutton_redirect_UDP_toggled" : self.set_redir_prot
            , "on_spinbutton_redirect_sport_changed" : self.set_redir_sport
            , "on_entry_redirect_gIP_changed" : self.set_redir_ip
            , "on_spinbutton_redirect_dport_changed" : self.set_redir_dport
            , "on_dialog_new_redirect_response" : response
            }
            self.dialog_new_redirect.signal_autoconnect(dic)  
            
            #print str(self.button_redirect_add.get_image().get_icon_name())
            #.get_name()
            if mode == "edit":
                self.button_redirect_add.set_label("Apply")
                #print "mode: " + str(mode)
                #stock = self.button_redirect_add.get_stock()
                #print "stock: " + str(stock) 
                image = gtk.Image()
                image.set_from_stock(gtk.STOCK_APPLY, gtk.ICON_SIZE_BUTTON)
                #image = gtk.Image()
                #image.set_from_stock(gtk.STOCK_OPEN, gtk.ICON_SIZE_BUTTON)
                
                self.button_redirect_add.set_image(image)
                self.dialog_new_redirect_widget.set_title("Edit selected redirection")
                #model, iter = self.treeview_networkcards.get_selection().get_selected()
                #counter = int(model.get_string_from_iter(iter))
                self.network_editredir = self.networkredirs[counter]
                self.tmpredir = self.network_editredir
                
                if self.network_editredir.protocol == "tcp":
                    self.radiobutton_redirect_TCP.set_active(True)
                if self.network_editredir.protocol == "udp":
                    self.radiobutton_redirect_UDP.set_active(True)                    
                #self.radiobutton_redirect_TCP.set_text(str(self.network_editredir.ip))
                #self.radiobutton_redirect_UDP.set_text(str(self.network_editredir.mac))
                #self.spinbutton_redirect_sport.set_value(int(self.network_editredir.sport))
                self.spinbutton_redirect_sport.set_value(int(self.network_editredir.sport))
                self.entry_redirect_gIP.set_text(str(self.network_editredir.ip))
                self.spinbutton_redirect_dport.set_value(int(self.network_editredir.dport))
                   
     
    def dialog_network_add_redirect_response(self, widget, response, *entry):    
        if response == gtk.RESPONSE_CLOSE:
            self.tmpredir = []
            widget.destroy ()
            #pass   
        if response == gtk.RESPONSE_APPLY:
            self.networkredirs.append(copy(self.tmpredir))
            #command = self.tmpredir.create_qemucommand()
            #print "command: " + str(command)
            
            #self.tmpredir = []
            self.refresh_redirects()
            print "Network stored"
            #widget.destroy ()
            self.button_apply_imagesettings.set_sensitive(True)
            self.button_restore_imagesettings.set_sensitive(True)
            
    def dialog_network_edit_redirect_response(self, widget, response, *entry):    
        if response == gtk.RESPONSE_CLOSE:
            self.tmpredir = []
            widget.destroy ()
            #pass   
        if response == gtk.RESPONSE_APPLY:
            #self.networksetup.append(self.tmpnetwork)
            self.network_editredir = copy(self.tmpredir)
            #command = self.tmpredir.create_qemucommand()
            #print "command: " + str(command)
            #self.tmpredir = []
            self.refresh_redirects()
            print "Redirection changed"
            #widget.destroy ()
            self.button_apply_imagesettings.set_sensitive(True)
            self.button_restore_imagesettings.set_sensitive(True) 
            
    def refresh_redirects(self, *event):
        #model = self.create_model_networkcards([])
        model = self.treeview_redirects.get_model()
        #self.add_columns_networkcards(self.treeview_networkcards,model)
        model.clear()
        #model.append(row=("None",))
        #try:
        curredirs = self.networkredirs
        if self.networkredirs != []:
            for redir in curredirs:
                protocol = redir.protocol
                sport = redir.sport
                ip = redir.ip
                dport = redir.dport
    
                model.append(row=(protocol,sport,ip,dport))
                print "Redirect: " + str(protocol) + " " + str(sport) + " " + str(ip) + " " + str(dport)            
                 
    def create_model_redirects(self, data):
        store = gtk.ListStore(gobject.TYPE_STRING,
                          gobject.TYPE_STRING,
                          gobject.TYPE_STRING,
                          gobject.TYPE_STRING)
        for item in data:
            iter = store.append()
            protocol = item[0]
            sport = item[1]
            ip = item[2]
            dport = item[3]
            
            #print itempath
            #print itemname
            store.set(iter, 0, item[0], 1, item[1], 2, item[2], 3, item[3])
        return store    

    def add_columns_redirects(self, treeview, model):
    
        renderer = gtk.CellRendererToggle()
        column0 = gtk.TreeViewColumn(_('Protocol'), gtk.CellRendererText(), text=0)
        column1 = gtk.TreeViewColumn(_('Source port'), gtk.CellRendererText(), text=1)
        column2 = gtk.TreeViewColumn(_('Guest IP'), gtk.CellRendererText(), text=2)
        column3 = gtk.TreeViewColumn(_('Dest. port'), gtk.CellRendererText(), text=3)
        treeview.append_column(column0)   
        treeview.append_column(column1)        
        treeview.append_column(column2) 
        treeview.append_column(column3)  
        
    def set_redir_prot(self, widget):
        wname = widget.get_name()
        
        if wname == "radiobutton_redirect_TCP":
            self.tmpredir.protocol = "tcp"
        elif wname == "radiobutton_redirect_UDP":
            self.tmpredir.protocol = "udp"
                        
        #print "Set tmpnetwork protocol to: " + str(self.tmpredir.protocol)
        
    def set_redir_sport(self, *widget):
        port = int(self.spinbutton_redirect_sport.get_value())
        #print "changed sport to: " + str(port)
        self.tmpredir.sport = port    
        
    def set_redir_ip(self, widget):
        ip = widget.get_text()
        self.tmpredir.ip = ip
        #print "Set tmpredir ip to: " + str(self.tmpredir.ip)          
        
    def set_redir_dport(self, *widget):
        port = int(self.spinbutton_redirect_dport.get_value())
        #print "changed dport to: " + str(port)
        self.tmpredir.dport = port    
        
    def remove_redirect(self, widget):
        #sel = self.treeview_networkcards.get_selection().get_selected()
        try:
            model, iter = self.treeview_redirects.get_selection().get_selected()
            protocol = model.get_value(iter, 0)
            sport = model.get_value(iter, 1)
            ip = model.get_value(iter, 2)
            dport = model.get_value(iter, 3)
            
            #print str(iter)
            counter = int(model.get_string_from_iter(iter))
            #print "selected counter:" + str(counter)
            del self.networkredirs[counter]
            #print "selected redir:" + str(protocol) + " - " + str(sport) + " - " + str(ip) + " - " + str(dport)
            #print str(model)
            #self.tmpnetwork = []
            self.refresh_redirects()  
            self.button_apply_imagesettings.set_sensitive(True)
            self.button_restore_imagesettings.set_sensitive(True)
        except:
            print "No redirection selected"       
            
    def set_smbsettings(self, widget):    
        if widget == self.checkbutton_smbshare:
            self.smbsettings.usesmb = widget.get_active()
        elif widget == self.filechooserbutton_network_smbshare:
            self.smbsettings.smbpath = widget.get_filename()  
        #print "smbsettings: " + str(self.smbsettings.usesmb) + " - " + str(self.smbsettings.smbpath)
        self.button_apply_imagesettings.set_sensitive(True)
        self.button_restore_imagesettings.set_sensitive(True)
            #ip = widget.get_text()
        #self.tmpredir.ip = ip                
                 
                 
    def create_model_jobmon_volumes(self, data):
        store = gtk.ListStore(gobject.TYPE_STRING,
                          gobject.TYPE_STRING)
        data.sort()    
        
        for item in data:
            iter = store.append()
            itempath = item[0]
            itemname = item[1]
            #print itempath
            #print itemname
            store.set(iter, 0, item[0], 1, item[1])
        return store      
    
    def add_columns_jobmon_volumes(self, treeview, model):
    
        renderer = gtk.CellRendererToggle()
        column = gtk.TreeViewColumn(_('Device'), gtk.CellRendererText(), text=0)
        
        column2 = gtk.TreeViewColumn(_('Mounted Volume'), gtk.CellRendererText(), text=1)
        treeview.append_column(column)   
        treeview.append_column(column2)        
        
    def create_model_usbhost(self, data):
        store = gtk.ListStore(gobject.TYPE_STRING,
                          gobject.TYPE_STRING)
        data.sort()
        
        for item in data:
            iter = store.append()
            itempath = item[0]
            itemname = item[1]
            #print itempath
            #print itemname
            store.set(iter, 0, item[0], 1, item[1])
        return store  
        
    def create_model_usbguest(self, data):
        store = gtk.ListStore(gobject.TYPE_STRING,
                          gobject.TYPE_STRING,
                          gobject.TYPE_STRING)
        data.sort()
        try:
            for item in data:
                iter = store.append()
                device = item[0]
                usbtype = item[1]
                name = item[2]
                #print device
                #print usbtype
                #print name
                store.set(iter, 0, item[0], 1, item[1], 2, item[2])
            return store          
        except:
            print "recieved no correct data for treemodel creation"
   
    def add_columns_usbhost(self, treeview, model):
    
        renderer = gtk.CellRendererToggle()
        column = gtk.TreeViewColumn(_('Type'), gtk.CellRendererText(), text=0)
        column2 = gtk.TreeViewColumn(_('Device'), gtk.CellRendererText(), text=1)
        treeview.append_column(column)   
        treeview.append_column(column2)      
        
    def add_columns_usbguest(self, treeview, model):
    
        renderer = gtk.CellRendererToggle()
        column = gtk.TreeViewColumn(_('Device'), gtk.CellRendererText(), text=0)
        column2 = gtk.TreeViewColumn(_('Type'), gtk.CellRendererText(), text=1)
        column3 = gtk.TreeViewColumn(_('Name'), gtk.CellRendererText(), text=2)
        treeview.append_column(column)   
        treeview.append_column(column2)       
        treeview.append_column(column3)     
    
    def refresh_usbhost(self, *widget):    
        #ilistmodel = self.isolist.get_model() 
        data=self.usbhost_list
        data.sort()
        model = self.create_model_usbhost(data)    
        self.treeview_usbhost.set_model(model)    
        
    def refresh_usbguest(self, *widget):    
        #ilistmodel = self.isolist.get_model() 
        data=self.usbguest_list
        data.sort()
        model = self.create_model_usbguest(data)    
        self.treeview_usbguest.set_model(model)         
        
    def pop_up_volumes(self, widget, event):
        
        if event.button == 3:
            sel = self.treeview_jobmon_volumes.get_selection().get_selected()
            #print "iter: " + str(sel[1])
            model = self.treeview_jobmon_volumes.get_model()
            try:
                self.selected_volume = model.get_value(sel[1], 0)
                #print str(self.selected_volume)           
                self.menu_popup_volumes.popup(None, None, None, 3, 0)         
            except:
                print "no volume selected"
                self.selected_volume = ""        
    
    def pop_up_usbhost(self, widget, event):
        
        if event.button == 3:
            sel = self.treeview_usbhost.get_selection().get_selected()
            #print "iter: " + str(sel[1])
            model = self.treeview_usbhost.get_model()
            self.selected_usb_hostdev = model.get_value(sel[1], 1)

            #print str(self.selected_usb_hostdev)
            self.menu_popup_usbhost.popup(None, None, None, 3, 0)    
            
    def pop_up_usbguest(self, widget, event):
        
        if event.button == 3:
            sel = self.treeview_usbguest.get_selection().get_selected()
            #print "iter: " + str(sel[1])
            model = self.treeview_usbguest.get_model()
            try:
                self.selected_usb_guestdev = model.get_value(sel[1], 0)
                #print str(self.selected_usb_guestdev)                
            except:
                print "no guest usbdevice selected"
                self.selected_usb_guestdev = ""


            self.menu_popup_usbguest.popup(None, None, None, 3, 0)             
        
    def usbhost_attach(self, widget):
        selection = self.selected_usb_hostdev
        #print "selection: " + str(selection)
        #devadr = re.search("[0-9a-f]{4}\:[0-9a-f]{4}", selection).group()
        if selection != "":
            devadr = re.search("[0-9a-f]{4}\:[0-9a-f]{4}", selection).group()
            #print "devadr" + devadr
            addcommand = "usb_add host:" + str(devadr)
            c = 0
            print "waiting for another qemu command..."
            while self.block_jobmon_update == True and c < 200:
                print "- " + str(c)
                time.sleep(0.3)      
                c = c+1  
                
            ptsin = PtsWrite(self.currentpts, addcommand)
            ptsin.start()
            c = 0
            while ptsin.isAlive() and c < 800:
                #print "waiting for thread ptsin"
                c = c+1
                time.sleep(0.3)

            commandstack =[["info usbhost",newqemu.treeview_usbhost],["info usb",newqemu.treeview_usbguest]]
            c = 0
            print "waiting for another qemu command..."
            while self.block_jobmon_update == True and c < 200:
                print "- " + str(c)
                time.sleep(0.3)      
                c = c+1         
            refreshlist = RefreshSysmon(self.currentpts, commandstack)
            refreshlist.start()
            #while refreshlist.isAlive() and c < 800:
                #print "waiting for thread ptsin"
             #   c = c+1
            #    time.sleep(0.3)            
            
            #self.jobman_get_usbguest()
            #self.refresh_usbguest()
        else:
            print "no device selected!"
        #self.usbhost_list.append([line1,line,devadr.group()])
        
    def usbguest_detach(self, widget):
        selection = self.selected_usb_guestdev
        #print "selection: " + str(selection)
        #devadr = re.search("[0-9a-f]{4}\:[0-9a-f]{4}", selection).group()
        if selection != "":
            devadr = re.search("[0-9]+\.[0-9]+", selection).group()
            string.strip(devadr)
            #print devadr
            delcommand = "usb_del " + str(devadr)
            ptsin = PtsWrite(self.currentpts, delcommand)
            ptsin.start()
            c = 0
            while ptsin.isAlive() and c < 800:
                #print "waiting for thread ptsin"
                c = c+1
                time.sleep(0.3)            
            commandstack =[["info usbhost",newqemu.treeview_usbhost],["info usb",newqemu.treeview_usbguest]]
            refreshlist = RefreshSysmon(self.currentpts, commandstack)
            refreshlist.start()            
            #self.refresh_usbguest()
        else:
            print "no device selected!"        
            
    def volume_eject(self, widget):
        selection = str(self.selected_volume)
        #print "selection: " + str(selection)
        #devadr = re.search("[0-9a-f]{4}\:[0-9a-f]{4}", selection).group()
        if selection != "":
            #devadr = re.search("[0-9]+\.[0-9]+", selection).group()
            #string.strip(devadr)
            #print devadr
            command = "eject " + str(selection)
            c = 0
            print "waiting for another qemu command..."
            while self.block_jobmon_update == True and c < 200:
                print "- " + str(c)
                time.sleep(0.3)      
                c = c+1
                
            ptsin = PtsWrite(self.currentpts, command)
            ptsin.start()
            c = 0
            while ptsin.isAlive() and c < 800:
                #print "waiting for thread ptsin"
                c = c+1
                time.sleep(0.3)    
            time.sleep(3)        
            commandstack =[["info block",self.treeview_jobmon_volumes]]
            
            c = 0
            print "waiting for another qemu command..."
            while self.block_jobmon_update == True and c < 200:
                print "- " + str(c)
                time.sleep(0.3)      
                c = c+1           
            refreshlist = RefreshSysmon(self.currentpts, commandstack)
            refreshlist.start()            
            #self.refresh_usbguest()
        else:
            print "no device selected!"                 
        
    def init_jobmanager(self, *widget):
        self.dialog_jobmonitor = gtk.glade.XML(self.gladefile, "dialog_jobmonitor", APP)
        toolbutton_pause_job = self.dialog_jobmonitor.get_widget("toolbutton_pause_job")
        toolbutton_rerun_job = self.dialog_jobmonitor.get_widget("toolbutton_rerun_job")
        toolbutton_stop_job = self.dialog_jobmonitor.get_widget("toolbutton_stop_job")
        toolbutton_reset_job = self.dialog_jobmonitor.get_widget("toolbutton_reset_job")
        self.treeview_usbhost = self.dialog_jobmonitor.get_widget("treeview_usbhost")
        self.treeview_usbguest = self.dialog_jobmonitor.get_widget("treeview_usbguest")
        self.treeview_jobmon_volumes = self.dialog_jobmonitor.get_widget("treeview_jobmon_volumes")
        
        self.combobox_jobmon_hda = self.dialog_jobmonitor.get_widget("combobox_jobmon_hda")
        self.combobox_jobmon_hdb = self.dialog_jobmonitor.get_widget("combobox_jobmon_hdb")
        self.combobox_jobmon_hdc = self.dialog_jobmonitor.get_widget("combobox_jobmon_hdc")
        self.combobox_jobmon_hdd = self.dialog_jobmonitor.get_widget("combobox_jobmon_hdd")
        self.combobox_jobmon_fda = self.dialog_jobmonitor.get_widget("combobox_jobmon_fda")
        self.combobox_jobmon_fdb = self.dialog_jobmonitor.get_widget("combobox_jobmon_fdb")
        self.combobox_jobmon_cdrom = self.dialog_jobmonitor.get_widget("combobox_jobmon_cdrom")
        
        self.button_jobmon_eject_hda = self.dialog_jobmonitor.get_widget("button_jobmon_eject_hda")
        self.button_jobmon_eject_hdb = self.dialog_jobmonitor.get_widget("button_jobmon_eject_hdb")
        self.button_jobmon_eject_hdc = self.dialog_jobmonitor.get_widget("button_jobmon_eject_hdc")
        self.button_jobmon_eject_hdd = self.dialog_jobmonitor.get_widget("button_jobmon_eject_hdd")
        self.button_jobmon_eject_fda = self.dialog_jobmonitor.get_widget("button_jobmon_eject_fda")
        self.button_jobmon_eject_fdb = self.dialog_jobmonitor.get_widget("button_jobmon_eject_fdb")
        self.button_jobmon_eject_cdrom = self.dialog_jobmonitor.get_widget("button_jobmon_eject_cdrom")
        
        self.button_jobmon_apply_hda = self.dialog_jobmonitor.get_widget("button_jobmon_apply_hda")      
        self.button_jobmon_apply_hdb = self.dialog_jobmonitor.get_widget("button_jobmon_apply_hdb")   
        self.button_jobmon_apply_hdc = self.dialog_jobmonitor.get_widget("button_jobmon_apply_hdc") 
        self.button_jobmon_apply_hdd = self.dialog_jobmonitor.get_widget("button_jobmon_apply_hdd") 
        self.button_jobmon_apply_fda = self.dialog_jobmonitor.get_widget("button_jobmon_apply_fda") 
        self.button_jobmon_apply_fdb = self.dialog_jobmonitor.get_widget("button_jobmon_apply_fdb") 
        self.button_jobmon_apply_cdrom = self.dialog_jobmonitor.get_widget("button_jobmon_apply_cdrom") 
        
        self.menu_widgets_volumes = gtk.glade.XML(self.gladefile,"menu_popup_volumes", APP)
        self.menu_popup_volumes = self.menu_widgets_volumes.get_widget("menu_popup_volumes")
        self.item_eject_volume = self.menu_widgets_volumes.get_widget("item_eject")
        
        self.menu_widgets_usbhost = gtk.glade.XML(self.gladefile,"menu_popup_usbhost", APP)
        self.menu_popup_usbhost = self.menu_widgets_usbhost.get_widget("menu_popup_usbhost")
        self.item_attach_device_usbhost = self.menu_widgets_usbhost.get_widget("item_attach_device")

        self.menu_widgets_usbguest = gtk.glade.XML(self.gladefile,"menu_popup_usbguest", APP)
        self.menu_popup_usbguest = self.menu_widgets_usbguest.get_widget("menu_popup_usbguest")
        self.item_detach_device_usbguest = self.menu_widgets_usbguest.get_widget("item_detach_device")
        
        self.usbhost_list = []
        self.usbguest_list = []
        self.jobman_volumes_list = []
        #self.jobman_get_usbhost()
        #time.sleep(1.5)
        #self.jobman_get_usbguest()   
        #self.jobman_get_usbhost()   

            
        self.combobox_jobmon_fda.set_model(self.cdimodel) 
        self.combobox_jobmon_fdb.set_model(self.cdimodel) 
        self.combobox_jobmon_cdrom.set_model(self.cdimodel) 
        
        self.combobox_jobmon_fda.set_active(0)
        self.combobox_jobmon_fdb.set_active(0)
        self.combobox_jobmon_cdrom.set_active(0)
        
        vmodel = self.create_model_jobmon_volumes(self.jobman_volumes_list)
        self.treeview_jobmon_volumes.set_model(vmodel)
        self.add_columns_jobmon_volumes(self.treeview_jobmon_volumes, vmodel)   
        vmodel.append(row=(" ",_('wait') + " " + _('loading mounted block devices')))
        
        hmodel = self.create_model_usbhost(self.usbhost_list)
        self.treeview_usbhost.set_model(hmodel)
        self.add_columns_usbhost(self.treeview_usbhost, hmodel)         
        hmodel.append(row=(" ",_('wait') + " " + _('loading usb_host devices')))

        
        gmodel = self.create_model_usbguest(self.usbguest_list)
        self.treeview_usbguest.set_model(gmodel)

        self.add_columns_usbguest(self.treeview_usbguest, gmodel)     
        gmodel.append(row=(" ",_('wait') + " " + _('loading usb_guest devices')," "))        
    
        dicjobmon = {"on_dialog_jobmonitor_response" : self.dialog_jobmonitor_response
        , "on_toolbutton_stop_job_clicked" : self.stop_job
        , "on_toolbutton_pause_job_clicked" : self.pause_job
        , "on_toolbutton_rerun_job_clicked" : self.cont_job    
        , "on_toolbutton_reset_job_clicked" : self.reset_job
        , "on_treeview_usbhost_button_press_event"  : self.pop_up_usbhost
        , "on_treeview_usbguest_button_press_event"  : self.pop_up_usbguest
        , "on_treeview_jobmon_volumes_button_press_event"  : self.pop_up_volumes
        , "on_button_jobmon_apply_hda_clicked" : self.jobman_change_volume
        , "on_button_jobmon_apply_hdb_clicked" : self.jobman_change_volume
        , "on_button_jobmon_apply_hdc_clicked" : self.jobman_change_volume
        , "on_button_jobmon_apply_hdd_clicked" : self.jobman_change_volume
        , "on_button_jobmon_apply_fda_clicked" : self.jobman_change_volume
        , "on_button_jobmon_apply_fdb_clicked" : self.jobman_change_volume
        , "on_button_jobmon_apply_cdrom_clicked" : self.jobman_change_volume
       # , "on_attach_device_activate" :  self.usbhost_attach
        }
        self.dialog_jobmonitor.signal_autoconnect(dicjobmon)  
        
        dic_menu_volumes = {"on_item_eject_activate" : self.volume_eject,
        }
        self.menu_widgets_volumes.signal_autoconnect(dic_menu_volumes)
        
        dic_menu_usbhost = {"on_attach_device_activate" : self.usbhost_attach,
        }
        self.menu_widgets_usbhost.signal_autoconnect(dic_menu_usbhost)
        
        dic_menu_usbguest = {"on_detach_device_activate" : self.usbguest_detach,
        }
        self.menu_widgets_usbguest.signal_autoconnect(dic_menu_usbguest)  
        time.sleep(0.2)

        c = 0
        print "waiting for another qemu command..."
        while self.block_jobmon_update == True and c < 200:
            
            print "- " + str(c)
            time.sleep(0.3)      
            c = c+1         
        commandstack =[["info block",self.treeview_jobmon_volumes],["info usbhost",self.treeview_usbhost],["info usb",self.treeview_usbguest]]
        RefreshSysmon(self.currentpts, commandstack).start()
     
         
      
        
    def dialog_jobmonitor_response(self, widget, response, *entry):    
        if response == gtk.RESPONSE_CLOSE:
            widget.destroy ()
            pass    
            
    def jobman_change_volume(self, widget):
        #selection = self.selected_usb_guestdev
        #selection = self.combobox_jobmon_%s.get_active() %volume
        
        wname = widget.get_name()

        #self.hdd_image = item
        #print "widget name: " + wname
        if wname == 'button_jobmon_apply_hda':
            volume = "hda"
            combo = self.combobox_jobmon_hda
        if wname == 'button_jobmon_apply_hdb':
            volume = "hdb"
            combo = self.combobox_jobmon_hdb
        if wname == 'button_jobmon_apply_hdc':
            volume = "hdc"
            combo = self.combobox_jobmon_hdc
        if wname == 'button_jobmon_apply_hdd':
            volume = "hdd"
            combo = self.combobox_jobmon_hdd
        if wname == 'button_jobmon_apply_fda':
            volume = "fda"
            combo = self.combobox_jobmon_fda
        if wname == 'button_jobmon_apply_fdb':
            volume = "fdb"
            combo = self.combobox_jobmon_fdb
        if wname == 'button_jobmon_apply_cdrom':
            volume = "cdrom"
            combo = self.combobox_jobmon_cdrom
            
            
        active = combo.get_active()
        model = combo.get_model()
        row = model[active]
        item = row[0]
        
        image = item    
        cdrpath = self.cdrom_path_by_name(image)
        if cdrpath != "None":
            image = cdrpath   
        
        #print "selection: " + str(volume) + " " + str(image)
        #devadr = re.search("[0-9a-f]{4}\:[0-9a-f]{4}", selection).group()
        if image != "" and image != "None":
            #devadr = re.search("[0-9]+\.[0-9]+", selection).group()
            #string.strip(devadr)
            #print devadr
            #volume = "/dev/fd0"
            command = "change " + str(volume) + " " + str(image)
            c = 0
            print "waiting for another qemu command..."
            while self.block_jobmon_update == True and c < 200:
                
                print "- " + str(c)
                time.sleep(0.3)      
                c = c+1          
            
            ptsin = PtsWrite(self.currentpts, command )
            ptsin.start()
            c = 0
            #self.block_jobmon_update = True
            print "waiting for thread ptsin"
            while ptsin.isAlive() and c < 800:
                print "- " + str(c)
                c = c+1
                time.sleep(0.3)      
            #self.block_jobmon_update = False
            print "write command done"
            #refreshlist = RefreshSysmon(self.currentpts)
            #refreshlist.start()            
            #self.refresh_usbguest()
            time.sleep(3)
            c = 0
            print "waiting for another qemu command..."
            while self.block_jobmon_update == True and c < 200:
                print "- " + str(c)
                time.sleep(0.3)      
                c = c+1    
            #time.sleep(3)     
            commandstack =[["info block",self.treeview_jobmon_volumes]]
            refreshlist = RefreshSysmon(self.currentpts, commandstack)
            refreshlist.start() 
            #self.block_jobmon_update = False
        else:
            print "no device selected!"                
                    
                    
    

## Start main app ##################################
    def __init__(self):
    #def __init__ (self,ip):
        Thread.__init__(self)


    #def run ( self ):
        print "qemulator startup..."
        
        self.cdrmedium = ""
        self.imagespath = ""
        self.ilist_data = []
        #self.default_machine_icon = "icons/default.png"
        self.default_machine_icon = "icons/default.png"
        
        
        self.bootmedium = "None"
        self.boot_driveletter = ""
        self.bootfromcd = False
        self.currentimage = ""
        self.cdrimage = "None"
        self.hda_image = None
        self.hdb_image = None
        self.hdc_image = None
        self.hdd_image = None
        self.fda_image = None
        self.fdb_image = None
        self.soundhw = ""
        self.vgamode = "default"
        self.novga = False
        self.usevnc = "novnc"
        self.vncdisplay = 1
        self.memory = "128"
        self.useusb = False
        
        self.snapshotmode = False
        self.localtimemode = False
        self.networkoptions = ""
        self.networkmode = "usernet"
        self.networksetup = []
        self.networkredirs = []
        self.network_hostname = "emu"
        self.usernetwork = Network_Usernet()
        self.smbsettings = Network_SMB()
        #self.smbsettings.usesmb = False
        self.customoptions  = "" 
        self.joblist_data = []
        self.emusystem = ""
        self.machinecommand = ""
        self.machine = ""
        self.jobmessage = []
        self.dorun = True
        self.doexit = False
        self.block_jobmon_update = False
        
        self.settings_autoshow = True
        self.settings_autohide = True
        self.default_iconsize = 24       
        #self.settings_autoshow = True
        #self.settings_autohide = False
        
        #self.qemu_command = "qemu"
        #self.emusystem = self.emusystem_path_by_name(self.emusystem)
        
        self.gladefile = "qemulator.glade"  
        self.wTree = gtk.glade.XML(self.gladefile, "window1", APP)
        #self.w2 = gtk.glade.XML(self.gladefile, "window2", APP)
      
        #self.load_settings()
        
        self.vpaned_mainwindow = self.wTree.get_widget("vpaned_mainwindow")
        self.vbox_topane = self.wTree.get_widget("vbox_topane")
        self.vbox_bottompane = self.wTree.get_widget("vbox_bottompane")
        self.button_togglesettings = self.wTree.get_widget("button_togglesettings")
        self.checkbutton_autoshow_settings = self.wTree.get_widget("checkbutton_autoshow_settings")
        self.checkbutton_autohide_settings = self.wTree.get_widget("checkbutton_autohide_settings")
        
        self.menu_widgets_mainmenu = gtk.glade.XML(self.gladefile,"menubar1", APP)
        self.menu_mainmenu = self.menu_widgets_mainmenu.get_widget("menubar1")
        
        self.menu_widgets_settingsmenu = gtk.glade.XML(self.gladefile,"menuitem_edit_menu", APP)
        self.item_set_autohide = self.menu_widgets_settingsmenu.get_widget("item_set_autohide")
        self.item_set_autoshow = self.menu_widgets_settingsmenu.get_widget("item_set_autoshow")
        
        #self.item_set_autohide = self.menu_widgets_mainmenu.get_widget("item_set_autohide")
        #self.item_set_autoshow = self.menu_widgets_mainmenu.get_widget("item_set_autoshow")
        
        #self.item_set_autoshow.set_active(True)
        self.isolist = self.wTree.get_widget("treeview_bootimages")
        self.treeview_bookmarks = self.wTree.get_widget("treeview_bookmarks")
        self.treeview_joblist = self.wTree.get_widget("treeview_joblist")
        self.treeview_cdrives = self.wTree.get_widget("treeview_cdrives")
        
        self.notebook_imgsettings = self.wTree.get_widget("notebook_imgsettings")
        
        self.combobox_imagedevice = self.wTree.get_widget("combobox_imagedevice")
        self.combobox_cdromdrive = self.wTree.get_widget("combobox_cdromdrive")
        self.combobox_imagecdrom = self.wTree.get_widget("combobox_imagecdrom")
        self.combobox_audiohw = self.wTree.get_widget("combobox_audiohw")
        self.combobox_emusystem = self.wTree.get_widget("combobox_emusystem")
        self.combobox_machinetype = self.wTree.get_widget("combobox_machinetype")
        
        self.filechooserbutton_hda = self.wTree.get_widget("filechooserbutton_hda")
        self.eventbox_filechooserbutton_hda = self.wTree.get_widget("eventbox_filechooserbutton_hda")
        self.filechooserbutton_hdb = self.wTree.get_widget("filechooserbutton_hdb")
        self.eventbox_filechooserbutton_hdb = self.wTree.get_widget("eventbox_filechooserbutton_hdb")
        self.filechooserbutton_hdc = self.wTree.get_widget("filechooserbutton_hdc")
        self.eventbox_filechooserbutton_hdc = self.wTree.get_widget("eventbox_filechooserbutton_hdc")
        self.filechooserbutton_hdd = self.wTree.get_widget("filechooserbutton_hdd")
        self.eventbox_filechooserbutton_hdd = self.wTree.get_widget("eventbox_filechooserbutton_hdd")
        self.filechooserbutton_fda = self.wTree.get_widget("filechooserbutton_fda")
        self.eventbox_filechooserbutton_fda = self.wTree.get_widget("eventbox_filechooserbutton_fda")
        self.filechooserbutton_fdb = self.wTree.get_widget("filechooserbutton_fdb") 
        self.eventbox_filechooserbutton_fdb = self.wTree.get_widget("eventbox_filechooserbutton_fdb")
        
        self.combobox_hda = self.wTree.get_widget("combobox_hda")
        self.combobox_hdb = self.wTree.get_widget("combobox_hdb")
        self.combobox_hdc = self.wTree.get_widget("combobox_hdc")
        self.combobox_hdd = self.wTree.get_widget("combobox_hdd")
        self.combobox_fda = self.wTree.get_widget("combobox_fda")
        self.combobox_fdb = self.wTree.get_widget("combobox_fdb")        
        
        
        self.radiobutton_cdromtype = self.wTree.get_widget("radiobutton_cdromtype")
        self.radiobutton_cdromtype1 = self.wTree.get_widget("radiobutton_cdromtype1")
        self.radiobutton_cdromtype2 = self.wTree.get_widget("radiobutton_cdromtype2")
        
        self.radiobutton_nokqemu = self.wTree.get_widget("radiobutton_nokqemu")
        self.radiobutton_kqemu = self.wTree.get_widget("radiobutton_kqemu") 
        self.radiobutton_kkqemu = self.wTree.get_widget("radiobutton_kkqemu") 
        
        self.checkbutton_usevga = self.wTree.get_widget("checkbutton_usevga") 
        self.checkbutton_novga = self.wTree.get_widget("checkbutton_novga") 
        self.checkbutton_startvnc = self.wTree.get_widget("checkbutton_startvnc")
        self.checkbutton_enable_usb = self.wTree.get_widget("checkbutton_enable_usb")
        self.checkbutton_bootcdrom = self.wTree.get_widget("checkbutton_bootcdrom")
        self.checkbutton_snapshotmode = self.wTree.get_widget("checkbutton_snapshotmode")
        self.checkbutton_localtime = self.wTree.get_widget("checkbutton_localtime")
        
        self.spinbutton_vncdisplay = self.wTree.get_widget("spinbutton_vncdisplay")
        self.spinbutton_memory = self.wTree.get_widget("spinbutton_memory")
        
        self.modulewindow = self.wTree.get_widget("vbox2")
        self.button_openimage_cancel = self.wTree.get_widget("button_openimage_cancel")
        self.entry_current_image = self.wTree.get_widget("entry_current_image")
        
        self.entry_networkline = self.wTree.get_widget("entry_networkline")
        self.entry_additional_options = self.wTree.get_widget("entry_additional_options")
        
        self.toolbutton_launch = self.wTree.get_widget("toolbutton_launch")
        self.toolbutton_launch_unmanaged = self.wTree.get_widget("toolbutton_launch_unmanaged")
        self.toolbutton_launchxterm = self.wTree.get_widget("toolbutton_launchxterm")
        
        self.button_add_bookmark = self.wTree.get_widget("button_add_bookmark")
        self.button_remove_bookmark = self.wTree.get_widget("button_remove_bookmark")
        
        self.button_apply_imagesettings = self.wTree.get_widget("button_apply_imagesettings")
        self.button_restore_imagesettings = self.wTree.get_widget("button_restore_imagesettings")
        self.label_imgsettings = self.wTree.get_widget("label_imgsettings")
        self.menu_widgets_imagelist = gtk.glade.XML(self.gladefile,"menu_popup_imagelist", APP)
        self.menu_popup_imagelist = self.menu_widgets_imagelist.get_widget("menu_popup_imagelist")
        dic_menu_imagelist = {"on_item_info_activate" : self.show_infomessage
        #, "on_item_bookmark_activate" : self.add_bookmark_list
        , "on_item_bookmark_activate" : self.add_bookmark
        }
        self.menu_widgets_imagelist.signal_autoconnect(dic_menu_imagelist)
        
        self.menu_widgets_bookmarks = gtk.glade.XML(self.gladefile,"menu_popup_bookmarks", APP)
        self.menu_popup_bookmarks = self.menu_widgets_bookmarks.get_widget("menu_popup_bookmarks")
        dic_menu_bookmarks = {"on_bookmark_info_activate" : self.show_infomessage_b
        , "on_delete_bookmark_activate" : self.remove_bookmark
        , "on_edit_bookmark_activate" : self.add_bookmark
        }
        self.menu_widgets_bookmarks.signal_autoconnect(dic_menu_bookmarks)       
       
        self.menu_widgets_joblist = gtk.glade.XML(self.gladefile,"menu_popup_joblist", APP)
        self.menu_popup_joblist = self.menu_widgets_joblist.get_widget("menu_popup_joblist")
        self.item_stop_job = self.menu_widgets_joblist.get_widget("item_stop_job")
        self.item_cont_job = self.menu_widgets_joblist.get_widget("item_cont_job")
        self.item_cont_job.set_sensitive(False)
        self.item_reset_job = self.menu_widgets_joblist.get_widget("item_reset_job")
        self.item_kill_job = self.menu_widgets_joblist.get_widget("item_kill_job")
        
        dic_menu_joblist = {"on_item_jobmonoitor_activate" : self.init_jobmanager
        ,"on_item_stop_job_activate" : self.pause_job
        , "on_item_cont_job_activate" : self.cont_job
        ,"on_item_reset_job_activate" : self.reset_job
        , "on_item_kill_job_activate" : self.stop_job        
        }
        self.menu_widgets_joblist.signal_autoconnect(dic_menu_joblist)            

        # Network widgets
        self.radiobutton_network_nonet = self.wTree.get_widget("radiobutton_network_nonet")
        self.radiobutton_network_usermode = self.wTree.get_widget("radiobutton_network_usermode")
        self.radiobutton_network_customsetup = self.wTree.get_widget("radiobutton_network_customsetup")
        
        self.button_network_netcard_add = self.wTree.get_widget("button_network_netcard_add")
        self.button_network_redir_add = self.wTree.get_widget("button_network_redir_add")
        self.button_network_edit = self.wTree.get_widget("button_network_edit")
        self.button_network_remove = self.wTree.get_widget("button_network_remove")
        self.treeview_networkcards = self.wTree.get_widget("treeview_networkcards")
        self.treeview_redirects = self.wTree.get_widget("treeview_redirects")
        self.label_network_netcards = self.wTree.get_widget("label_network_netcards")
        self.label__network_redirects = self.wTree.get_widget("label__network_redirects")
        self.filechooserbutton_network_smbshare = self.wTree.get_widget("filechooserbutton_network_smbshare")
        self.checkbutton_smbshare = self.wTree.get_widget("checkbutton_smbshare")
        self.entry_network_hostname = self.wTree.get_widget("entry_network_hostname")
        self.hbox_usernet_vlan = self.wTree.get_widget("hbox_usernet_vlan")
        self.label_hostname = self.wTree.get_widget("label_hostname")
        self.spinbutton_usernet_vlan = self.wTree.get_widget("spinbutton_usernet_vlan")
        
        self.gtext = gtk.TextBuffer(table=None)
        
        self.load_settings()
        
        
        self.kqemu_param = "-no-kqemu"
        
        self.image_settings  = { }
        self.image_settings["NULL"] = {"kqemu_param": "-kernel-kqemu", "bootmedium": "cdrom", "boot_driveletter": "d"}
        #filename = "image_settings"
        self.image_settings = self.getfromfile("image_settings")
        self.load_bookmarks()
        self.init_gui()

        #self.load_joblist()
        
 
        #gtk.main()  

        
        
        dic = {"on_window1_destroy" : self.delete_event
                ,"on_beenden1_activate" : self.destroy_event
                
                , "on_item_about_activate" : self.init_about
                , "on_item_create_image_activate" : self.init_create_image
                , "on_item_settings_activate" : self.init_settings
                #, "on_item_settings_autohide_activate" : self.menu_toggle_settings_autohide
                #, "on_item_settings_autoshow_activate" : self.menu_toggle_settings_autoshow
                
                , "on_checkbutton_autohide_settings_toggled" : self.menu_toggle_settings_autohide
                , "on_checkbutton_autoshow_settings_toggled" : self.menu_toggle_settings_autoshow
                
                
                , "on_item_quit_activate" : self.destroy_event
                
                , "on_toolbutton1_clicked" : self.get_soundhw
                , "on_toolbutton2_clicked" : self.button2_event
                , "on_toolbutton3_clicked" : self.button3_event
                , "on_toolbutton4_clicked" : self.init_settings
                , "on_toolbutton_launch_clicked" : self.run_qemu
                , "on_toolbutton_launch_unmanaged_clicked" : self.run_qemu_unmanaged
                , "on_toolbutton_launchxterm_clicked" : self.run_qemu_xterm
                
                , "on_vpaned_mainwindow_button_press_event" : self.vpane_doubleclick
                , "on_button_togglesettings_clicked" : self.toggle_settingsview
                #, "on_treeview_bootimages_row_activated_event" : self.treeview_selection
                , "on_treeview_bootimages_button_press_event" : self.pop_up_imagelist     
                , "on_treeview_bootimages_cursor_changed" : self.treeview_selection
                #, "on_treeview_cdrives_row_activated" : self.cdrive_selection
                
                , "on_treeview_cdrives_cursor_changed" : self.cdrive_selection                     
                           
                #, "on_treeview_bookmarks_row_activated_event" : self.bookmark_selection
                , "on_treeview_bookmarks_button_press_event" : self.pop_up_bookmarks
                , "on_treeview_bookmarks_cursor_changed" : self.bookmark_selection
                
                , "on_treeview_joblist_button_press_event" : self.pop_up_joblist
                
                #, "on_button1_clicked" : self.apply_changes
                , "on_button_apply_imagesettings_clicked" : self.store_emu_settings
                , "on_button_restore_imagesettings_clicked": self.fetch_currimage_config
                #, "on_button_apply_imagesettings_clicked" : self.button_apply_imagesettings.set_sensitive(False)
                , "on_combobox_imagedevice_changed" : self.select_bootimage
                , "on_combobox_cdromdrive_changed" : self.select_cdromdrive
                , "on_combobox_imagecdrom_changed" : self.select_cdromimage
                #, "on_combobox_imagecdrom_changed" : self.button_apply_imagesettings.set_sensitive(True)
                , "on_combobox_audiohw_changed" : self.select_soundhw
                , "on_combobox_emusystem_changed" : self.select_emusystem
                , "on_combobox_machinetype_changed" : self.select_machine
                , "on_combobox_hda_changed" : self.select_xtra_image
                , "on_combobox_hdb_changed" : self.select_xtra_image
                , "on_combobox_hdc_changed" : self.select_xtra_image
                , "on_combobox_hdd_changed" : self.select_xtra_image
                , "on_combobox_fda_changed" : self.select_xtra_image
                , "on_combobox_fdb_changed" : self.select_xtra_image  
                
                , "on_filechooserbutton_hda_selection_changed" : self.load_xtra_image
                , "on_filechooserbutton_hdb_selection_changed" : self.load_xtra_image
                , "on_filechooserbutton_hdc_selection_changed" : self.load_xtra_image
                , "on_filechooserbutton_hdd_selection_changed" : self.load_xtra_image
                , "on_filechooserbutton_fda_selection_changed" : self.load_xtra_image
                , "on_filechooserbutton_fdb_selection_changed" : self.load_xtra_image                              
                
                , "on_radiobutton_cdromtype_toggled" : self.no_xtracdrom
                , "on_radiobutton_cdromtype1_toggled" : self.select_mountcdrom
                , "on_radiobutton_cdromtype2_toggled" : self.select_imagecdrom
                , "on_checkbutton_bootcdrom_toggled" : self.set_bootfromcd
                
                , "on_radiobutton_nokqemu_toggled" : self.set_nokqemu
                , "on_radiobutton_kqemu_toggled" : self.set_kqemu
                , "on_radiobutton_kkqemu_toggled" : self.set_kkqemu
                
                , "on_checkbutton_usevga_toggled" : self.set_vgamode
                , "on_checkbutton_novga_toggled" : self.set_novga
                , "on_checkbutton_enable_usb_toggled" : self.set_usb
                , "on_checkbutton_snapshotmode_toggled" : self.set_snapshotmode
                , "on_checkbutton_localtime_toggled" : self.set_localtimemode
                
                , "on_checkbutton_startvnc_toggled" : self.set_startvnc
                , "on_spinbutton_vncdisplay_changed" : self.set_vncdisplay
                , "on_spinbutton_memory_changed" : self.set_memory
                #, "on_spinbutton_memory_input" : self.set_memory
                #, "on_spinbutton_memory_change_value" : self.set_memory
                
                , "on_button_load_image_clicked" : self.fileChooser_emuimage
                , "on_filechooserdialog_openimage_response" : self.fileChooser_emuimage_response
                
                , "on_button_add_bookmark_clicked" : self.add_bookmark
                , "on_button_remove_bookmark_clicked" : self.remove_bookmark
                , "on_entry_current_image_changed" : self.select_image_from_path
                # handlers for the network widgets
                , "on_button_network_netcard_add_clicked"  : self.init_networksetup
                , "on_button_network_redir_add_clicked" : self.init_network_redirect
                , "on_button_network_remove_clicked" : self.remove_netcard
                , "on_button_network_edit_clicked"  : self.init_networksetup
                , "on_entry_networkline_changed" : self.set_network
                , "on_button_defaultnet_clicked" : self.set_defaultnet
                , "on_entry_additional_options_changed" : self.set_customoptions
                , "on_radiobutton_network_nonet_toggled" : self.toggle_networkuse
                , "on_radiobutton_network_usermode_toggled" : self.toggle_networkuse
                , "on_radiobutton_network_customsetup_toggled" : self.toggle_networkuse
                , "on_entry_network_hostname_changed" : self.set_usernet_hostname
                , "on_spinbutton_usernet_vlan_changed" : self.set_usernet_vlan
                
                #, "on_treeview_networkcards_row_activated" : self.select_networkcard
                , "on_treeview_networkcards_cursor_changed" : self.select_networkcard
                #, "on_treeview_redirects_row_activated" : self.select_networkredir
                , "on_treeview_redirects_cursor_changed" : self.select_networkredir
                , "on_checkbutton_smbshare_toggled" : self.set_smbsettings
                , "on_filechooserbutton_network_smbshare_selection_changed" : self.set_smbsettings
                
                # handlers for the new image dialog
                , "on_filechooserbutton_newimage_dest_current_folder_changed" : self.set_newimage_folder
                , "on_entry_newimage_name_changed" : self.set_newimage_name
                , "on_combobox_newimage_format_changed" : self.set_newimageformat
                , "on_spinbutton_newimage_size_changed" : self.set_newimagesize
                , "on_combobox_newimage_sizeunit_changed" : self.set_newimagesize
                , "on_button_create_image_clicked" : self.create_newimage
                }
        self.wTree.signal_autoconnect(dic)
    def run(self): 
          
        self.load_joblist()
        gtk.main()  
      
class QemuOutThread ( Thread ):


   #def run ( self, qemucommand ):
    def __init__ (self, childout, childerr):
        Thread.__init__(self)
        self.childout = childout
        self.childerr = childerr
    def run(self):
        #print "QemuOutThread aufgerufen"
        while 1:
            #try:
            linerr = self.childerr.readline() 
            if linerr == "": break
            #print linerr
            m = re.search("/dev/pts/\d+", linerr)
            if m != None:
                self.currentpts = m.group()
    
            
        #print self.currentpts
        #print "ausgelesen"


class QemuPtsThread ( Thread ):

    def __init__ (self, caller, pts, image, runstat=1):
        #time.sleep(2)
        Thread.__init__(self)
        self.pts = pts
        self.image = image
        self.caller = caller
        self.runstat = runstat

        #self.returnmesg = "Success"

    def run(self):
        print "watcher demon for qemu job in terminal " + str(self.pts) + " started"
        #ptsout = open(self.pts, 'rb')
        newqemu.add_job(self.image, self.pts, self.runstat)
        
        while 1:
            if os.path.exists(self.pts):
                time.sleep(3)             
            else: 
                print self.pts + " not found - demon QUIT"
                try: 
                    newqemu.dialog_jobmonitor.get_widget("dialog_jobmonitor").destroy ()
                except:
                    print "No monitor open"
                time.sleep(0.3)
                newqemu.remove_job(self.image, self.pts, self.runstat)
                break
            if newqemu.dorun != True:
                print "mainapp closed, exit watcher demon for " + str(self.pts)
                break  
                
        
class RefreshSysmon ( Thread ):

    def __init__ (self, pts, commandstack):
        Thread.__init__(self)
        self.pts = pts
        #self.command = command
        self.outlist = []  
        self.commandstack = commandstack
                
    def run(self): 
        newqemu.block_jobmon_update = True
        time.sleep(1)
        for commandlist in self.commandstack:
            command = commandlist[0]
            #print "command: " + str(command) 
            treeview = commandlist[1]
            #print "treeview: " + str(treeview)
            ptsin = PtsWrite2(self.pts, command)
            ptsin.start()
            c = 0
            while ptsin.isAlive() and c < 200:
                #print "waiting for thread ptsin"
                c = c+1
                time.sleep(0.3)
                
            if newqemu.jobmessage == []:
                jobmessage = []
                if command == "info usbhost":
                    jobmessage.append(_('Timeout, no devices found') + ", -")
                    
                elif command == "info usb":
                    jobmessage.append(_('Timeout, no devices found') + ", -")
            else:
                jobmessage = newqemu.jobmessage
            
            data = self.resultfilter(jobmessage, command)
            #data=devlist
            #if data != []
            data.sort()
            #model = treeview.get_model() 
            #try:
            #print "model: " + str(model)
            #model.clear()
            #except:
            #    pass
            vmodel = newqemu.create_model_jobmon_volumes([])
            hmodel = newqemu.create_model_usbhost([]) 
            gmodel = newqemu.create_model_usbguest([])            
            if command == "info usbhost":
                model = hmodel
            elif command == "info usb":
                model = gmodel           
            elif command == "info block":
                model = vmodel
            else:
                model = treeview.get_model() 
                
            #print "model: " + str(model)
                 
            for dev in data:
                #print "dev: " + str(dev)
                if command == "info usbhost" and len(dev) == 3:
                    model.append(row=(dev[0],dev[1]))
                elif command == "info usb" and len(dev) == 3:
                    model.append(row=(dev[0],dev[1],dev[2]))
                elif command == "info block" and len(dev) == 2:
                    model.append(row=(dev[0],dev[1]))                    
 
            time.sleep(0.6)    
            treeview.set_model(model)
        newqemu.block_jobmon_update = False
        
    def resultfilter(self, filterlist, infocommand):
        lc = 0
        outlist = []
        for line in filterlist:
            line = line.replace ( 'u"\u001B"', '' )
            #print "LINE:::::::::::::::::: " + str(line)
            
            if infocommand == "info usbhost":
                nodevs = re.search(_('Timeout'), line)
                
                if nodevs != None:
                    devdata = line.split(", ", 1)
                    #outlist.append(["",line,""])
                    outlist.append(devdata)
                else:
                    if lc%2 == 0:
                        #print line
                        line1 = line
                    else:
                        devadr = re.search("[0-9a-f]{4}\:[0-9a-f]{4}", line)
                        if devadr != None:
                            outlist.append([line1,line,devadr.group()])
                        else:
                            outlist.append([line,line1,""])
                #lc = lc+1 
            elif infocommand == "info usb":
                devadr = re.search("[0-9a-f]{4}\:[0-9a-f]{4}", line)
                if devadr == None:
                    devdata = line.split(", ", 2)
                    outlist.append(devdata)
            elif infocommand == "info block":
                devdata = line.split(": ", 1)
                outlist.append(devdata)                    
                
            else:
                print "no result filter for " + str(filtertype) + " defined"
            lc = lc+1
        #print "prefiltering done"
        return outlist        
            
class PtsWrite2 ( Thread ):

    def __init__ (self, pts, command):
        Thread.__init__(self)
        self.pts = pts
        self.command = command
        self.outlist = []

    def run(self):
        #print "PtsWrite2 aufgerufen command: " + str(self.command)
        newqemu.block_jobmon_update = True
        call = "echo " + self.command + " > " + self.pts
        callclr = "echo '' > " + self.pts
        
        #time.sleep(1)
       # runit = os.popen(call)
       # time.sleep(3)
        runit = os.popen(call)
#        fo = open(self.pts,"r")
        #print "write done!"
        #teststring = "this is a dummy text"
#        print teststring[4:-1]
        time.sleep(0.5)
        #newqemu.block_jobmon_update = False
        #print "go on!"
        fo = open(self.pts,"r")
        

        commandline = re.search(self.command, fo.readline())
        #print "commandline1" + str(commandline)
        c = 0
        while commandline == None and c < 200:  
            commandline = re.search(self.command, fo.readline())
            try:
                if commandline.group() == self.command:
                    break
                    #print "commandline " + str(commandline.group) + " - " + str(c)
            except:
                pass
            #print "commandline " + str(commandline) + " - " + str(c)
            c = c+1        
            
        lct = 0                
        while os.path.exists(self.pts) and lct < 800:
        #while 1:
            #print "turn: " + str(lct)
            outres =  fo.readline()
            outres = string.strip(outres)
            outres = outres.replace ( u"\u001B", '' )
            outres = outres.replace ( '[K', '' )
            outres = outres.replace ( '[D', '' )
            #print "outres: \"" + str(outres) + "\""
            m = re.search("\w+", outres)
            q = re.match("\(qemu\)\w+", outres)
            Q = re.match("QEMU", outres)
            stopper = re.search("\(qemu\)", outres)

            er = re.search(str(self.command), outres)
            er2 = re.search("usb_add", outres)
            er3 = re.search("usb_del", outres)
            er4 = re.search("eject", outres)
            er5 = re.search("change", outres)

            if outres != "" \
                and outres != "(qemu)" \
                and q == None \
                and Q == None \
                and er == None \
                and er2 == None \
                and er3 == None \
                and er4 == None \
                and er5 == None \
                and stopper == None:
                self.outlist.append(str(outres))            

            if string.strip(outres) == "(qemu)":
                #print "stopper eingetreten: " + str(stopper.group()) + "bei line: " + str(lct) + "string: " + str(outres)
                lct = 0
                fo.close()
                break
            lct = lct+1
        print "READ DONE"   
        fo.close()  
        #print "result: " + str(self.outlist)
        newqemu.jobmessage = self.outlist
        #time.sleep(2)
        newqemu.block_jobmon_update = False


            
class PtsWrite ( Thread ):

    def __init__ (self, pts, command):
        Thread.__init__(self)
        self.pts = pts
        self.command = command

    def run(self):
        #print "PtsWrite aufgerufen"
        newqemu.block_jobmon_update = True
        call = "echo " + self.command + " > " + self.pts
        if os.path.exists(self.pts):
            runit = os.popen(call)
            print "PtsWrite done!"
        else: 
            print self.pts + " not found"
        newqemu.block_jobmon_update = False
        
#class Shell(Popen3):
#	def __init__(self):
#		Popen3.__init__(self, ('sh',))
#	def execute(self, line):
#		os.write(self.tochild.fileno(), line + '\n')
#		return os.read(self.fromchild.fileno(), 1024)    

#class Shell2(Popen3):
#    def __init__(self, pts):
#        #shcommand = "sh " + pts
#        shcommand = pts
#        Popen3.__init__(self, (shcommand,))
#    def execute(self, line):
#        os.write(self.tochild.fileno(), line + '\n')
#        return os.read(self.fromchild.fileno(), 1024)  
        
#8192
            
class PtsRead ( Thread ):
    def __init__ (self, pts, ptsout):
        Thread.__init__(self)
        self.pts = pts
        self.ptsout = ptsout
        self.outlist = []

    def run(self):
        #print "PtsRead aufgerufen"
        if os.path.exists(self.pts):
            #ptsout = open(self.pts, 'r')
            ptsout = self.ptsout
            
            lct = 0
            m = None
            q = None
            while os.path.exists(self.pts):
                outres =  ptsout.readline()
                outres = string.strip(outres)
                if lct != 0 and outres != "" and outres != "(qemu)":
                    self.outlist.append(str(outres))
                    
                m = re.search("\w+", outres)
                q = re.search("(qemu)", outres)
                lct = lct+1
                if q != None: 
                    #print q
                    lct = 0
                    ptsout.close()
                    break
                #ptsout.close()
                time.sleep(0.3)     
            print "READ DONE!"
        else: 
            print self.pts + " not found -  STOP"
        newqemu.jobmessage = self.outlist
        #return self.outlist   
class Network:        
    def __init__(self):
        #shcommand = "sh " + pts
        self.ntype = ""
        #self.nnumber = nnumber
        self.ip = ""
        self.port = "1"
        self.mac = ""
        self.vlan = "0"
        self.ttscript = ""
        self.ifname = ""
        self.ttfiledesc = ""
            
            
    def create_qemucommand(self):
        qemucommand = ""
        macommand = ""
        if self.mac != "":
            macommand = ",macaddr=" + self.mac
        ttscript_command = ""
        if self.ttscript != "":
            ttscript_command = ",script=" + str(self.ttscript)
        fdcommand = ",fd=" + str(self.ttfiledesc)
        listencommand = ",listen=" + str(self.ip) + ":" + str(self.port)
        connectcommand = ",connect=" + str(self.ip) + ":" + str(self.port)
        mcastcommand = ",mcast=" + str(self.ip) + ":" + str(self.port)
        ## build qemu commandlines for each setup    
        if self.ntype == "Open a TUN/TAP interface":
            #qemucommand = "-net nic,vlan=0,macaddr=3f:ff:2e:23:33:9d -net tap,vlan=0,ifname=net1,script=/dev/null"    
            #qemucommand = "-net nic,vlan=" + self.vlan + macommand + " -net tap,vlan=" + self.vlan + ",ifname=" + self.ifname + ",script=" + self.ttscript
            qemucommand = " -net nic,vlan=" + str(self.vlan) + macommand + " -net tap,vlan=" + str(self.vlan) + ",ifname=" + self.ifname + ttscript_command + " "
        elif self.ntype == "Use an already open TUN/TAP interface":
            qemucommand = " -net nic,vlan=" + str(self.vlan) + macommand + " -net tap,vlan=" + str(self.vlan) + fdcommand
        elif self.ntype == "Open a listening TCP socket":
            qemucommand = " -net nic,vlan=" + str(self.vlan) + macommand + " -net socket,vlan=" + str(self.vlan) + listencommand
        elif self.ntype == "Use an already open TCP socket":
            qemucommand = " -net nic,vlan=" + str(self.vlan) + macommand + " -net socket,vlan=" + str(self.vlan) + fdcommand
        elif self.ntype == "Connect to listening  TCP socket":
            qemucommand = " -net nic,vlan=" + str(self.vlan) + macommand + " -net socket,vlan=" + str(self.vlan) + connectcommand
        elif self.ntype == "Create shared VLAN via UDP multicast socket":  
            qemucommand = " -net nic,vlan=" + str(self.vlan) + macommand + " -net socket,vlan=" + str(self.vlan) + mcastcommand
        elif self.ntype == "Use an already open UDP multicast socket":
            qemucommand = " -net nic,vlan=" + str(self.vlan) + macommand + " -net socket,vlan=" + str(self.vlan) + fdcommand
        else:
            pass   
        return qemucommand
    
class Bookmark:        
    def __init__(self):
        self.name = "new machine"
        self.icon = "icons/default.png"    
        self.path = ""
        self.haveconfig = False
    def get_modeldata(self):

        icon = gtk.gdk.pixbuf_new_from_file(self.icon)
        #haveconfig = self.check_haveconfig(itempath)
        if self.haveconfig == True:
            config_icon = gtk.gdk.pixbuf_new_from_file('pixmaps/gtk-yes.png')
        else:
            config_icon = gtk.gdk.pixbuf_new_from_file('pixmaps/gtk-no.png')
        modeldata = [icon, self.name, self.path, config_icon]
        return modeldata
    def check_haveconfig(self, bootimage):
        haveconfig = False
        try:
            if self.image_settings[bootimage]:
                #print "Config for " + str(bootimage) + " found"
                haveconfig = True
            else:
                #print "No config for " + str(bootimage) + " found"
                haveconfig = False
        except:       
            #print "No config for " + str(bootimage) + " found"
            haveconfig = False
        return haveconfig    
    
    
class Network_Usernet:        
    def __init__(self):
        self.vlan = "0"
        self.hostname = "emu"
        #print "VLAN: " + str(self.vlan)
             
    def create_qemucommand(self): 
        #qemucommand = " -net nic,vlan=" + str(self.vlan) + " -net user,vlan=" + str(self.vlan) + ",hostname=" + str(self.hostname) + " "
        qemucommand = " -net nic,vlan=" + str(self.vlan) + " -net user,vlan=" + str(self.vlan) + ",hostname=" + str(self.hostname)
        return qemucommand    
    
class Network_SMB:        
    def __init__(self):
        self.usesmb = False
        self.smbpath = "./"
        #print "VLAN: " + str(self.vlan)
             
    def create_qemucommand(self): 
        if self.usesmb == True:
            #qemucommand = " -smb " + str(self.smbpath) + " "
            qemucommand = " -smb " + str(self.smbpath)
        else:
            qemucommand = " "            
        return qemucommand     
                                             
    
class Network_Redirection:        
    def __init__(self):
        #shcommand = "sh " + pts
        self.protocol = ""
        #self.nnumber = nnumber
        self.sport = "1"
        self.ip = ""            
        self.dport = "1"
            
    def create_qemucommand(self): 
        qemucommand = " -redir " + str(self.protocol) + ":" + str(self.sport) + ":" + str(self.ip) + ":" + str(self.dport) + " "
        qemucommand = " -redir " + str(self.protocol) + ":" + str(self.sport) + ":" + str(self.ip) + ":" + str(self.dport)
        return qemucommand
                        
    
def main():
    pass
    
newqemu = Qemulator()
newqemu.start()

if __name__ == "__main__":

    main()

    

